DECLARE FUNCTION CMDRampaDec$ (send%)
DECLARE FUNCTION CMDSmorzamenti$ (send%)
DECLARE FUNCTION CMDPercVel$ (send%)
DECLARE FUNCTION CMDSetErrSpdABS$ (send%)
DECLARE SUB TxRxSeriale (Comando$, TIPOCOMANDO%, NByteRx%)
DECLARE SUB CambiaMaschera (a%)
DECLARE FUNCTION PRGCMDStatus$ (send%)
DECLARE FUNCTION InsertCMD$ ()
DECLARE SUB decode (p$)
DECLARE FUNCTION CMDStatoDrv2$ (send%)
DECLARE FUNCTION CMDStatoDrv1$ (send%)
DECLARE FUNCTION CMDTipoDrv$ (send%)
DECLARE FUNCTION CMDVersioneSoft$ (send%)
DECLARE FUNCTION CMDStop$ (send%)
DECLARE FUNCTION CMDLetturaPosiz$ (send%)
DECLARE FUNCTION CMDStartUltimo$ (send%)
DECLARE FUNCTION CMDReset$ (send%)
DECLARE FUNCTION PRGCMDTestEeprom$ (send%)
DECLARE FUNCTION PRGCMDPausa$ (send%)
DECLARE FUNCTION PRGCMDEraseAll$ (send%)
DECLARE FUNCTION PRGCMDRepeat$ (send%)
DECLARE FUNCTION PRGCMDPrintAll$ (send%)
DECLARE FUNCTION PRGCMDStartAcq$ (send%)
DECLARE FUNCTION PRGCMDStopAcq$ (send%)
DECLARE FUNCTION PRGCMDWriteAddr$ (send%)
DECLARE FUNCTION PRGCMDReadAddr$ (send%)
DECLARE FUNCTION PRGCMDErase$ (send%, prog%)
DECLARE FUNCTION PRGCMDStart$ (send%)
DECLARE FUNCTION PRGCMDStop$ (send%)
DECLARE SUB MascheraAPSPRG ()
DECLARE SUB ApsPrgCommands (TastoInput$)
DECLARE FUNCTION CMDAttivaStepOut$ (send%)
DECLARE FUNCTION CMDStepGenNenc$ (send%)
DECLARE FUNCTION CMDSerialEcho$ (send%)
DECLARE FUNCTION CMDPassiActivInPos$ (send%)
DECLARE FUNCTION CMDPassiFrenata$ (send%)
DECLARE FUNCTION CMDQuotaInizialeZfly$ (send%)
DECLARE FUNCTION CMDHomeAbsSwitchall$ (send%)
DECLARE FUNCTION CMDFMaxMOV$ (send%)
DECLARE FUNCTION CMDSetAnout1$ (send%)
DECLARE FUNCTION CMDSetAnout2$ (send%)
DECLARE SUB SioCommands (TastoInput$)
DECLARE FUNCTION CMDSetOut$ (send%)
DECLARE SUB MascheraSIO ()
DECLARE FUNCTION CMDStopTrigExtOr$ (send%)
DECLARE FUNCTION CMDExtracorsa$ (send%)
DECLARE FUNCTION CMDAzzeramento$ (send%)
DECLARE FUNCTION CMDQuotammNoPos$ (send%)
DECLARE FUNCTION CMDStopTrigExt$ (send%)
DECLARE FUNCTION CMDStartTrigExt$ (send%)
DECLARE FUNCTION CMDPercVelAuto$ (send%)
DECLARE FUNCTION CMDPercVelocita$ (send%)
DECLARE SUB CMDQuotaGiro ()
DECLARE FUNCTION CMDQuotamm$ (send%)
DECLARE FUNCTION CMDZeroAlVolo$ (send%)
DECLARE FUNCTION CMDRitardoSeriale$ (send%)
DECLARE FUNCTION CMDRiduzioneCorr$ (send%)
DECLARE FUNCTION CMDLivelloInPos$ (send%)
DECLARE FUNCTION CMDSetHome$ (send%)
DECLARE FUNCTION CMDDivisionePasso$ (send%)
DECLARE FUNCTION CMDVMin$ (send%)
DECLARE FUNCTION CMDVMax$ (send%)
DECLARE SUB ApsCommands (TastoInput$)
DECLARE SUB AbsCommands (TastoInput$)
DECLARE FUNCTION CMDMovInfinito$ (send%)
DECLARE FUNCTION CMDMovAssoluto$ (send%)
DECLARE FUNCTION SpecialInput# (min#, max#, NChr%)
DECLARE FUNCTION CMDMovRelativo$ (send%)
DECLARE FUNCTION CMDRampa$ (send%)
DECLARE FUNCTION CMDFMax$ (send%)
DECLARE FUNCTION CMDFMin$ (send%)
DECLARE SUB UpdateStatusLine ()
DECLARE FUNCTION BnbAdd$ (Comando$)
DECLARE SUB CMDSetSerial ()
DECLARE FUNCTION CMDCurrentSet$ (send%)
DECLARE SUB CMDSetAddr ()
DECLARE SUB DecToBin (ValoreDec%, Bin$)
DECLARE SUB BinToDec (Bin$, ValoreDec%)
DECLARE SUB MascheraAPS ()
DECLARE SUB MascheraABS ()

DECLARE FUNCTION CalcoloChksum% (Comando$)
DECLARE FUNCTION ConvHEX$ (stringa$)
DECLARE FUNCTION CMDStopRmp$ (send%)
DECLARE FUNCTION CMDStopImm$ (send%)
DECLARE FUNCTION CMDReadAnin1$ (send%)
DECLARE FUNCTION CMDReadAnin2$ (send%)
DECLARE FUNCTION CMDReadInSio$ (send%)
DECLARE FUNCTION PRGCMDEdit$ (send%)

ON ERROR GOTO GestioneErrore

'*******************************************************
'*                   TERMINALE i.v.b.                  *
'*                                                     *
'*       PROGRAMMA DI TEST COMUNICAZIONE SERIALE       *
'*                                                     *
'*    VERSIONE MULTILINGUA ITALIANO/INGLESE/tedesco    *
'*                                                     *
'*******************************************************

'$DYNAMIC

DEFINT A-Z
DIM SHARED indirizzo, DRIVER$
DIM SHARED Cmd$(20)
DIM SHARED ADDRESS, CORRENTE#, FMAX#, FMIN, RAMPA, MOVREL#
DIM SHARED BAUD$, COM$, RECEIVE$
DIM SHARED ABORTCOMMAND, SETADDRESS, SWITCHALL
DIM SHARED TOGGLECOLOR
DIM SHARED COLORECOM, COLORECOM1, COLORECOM2
DIM SHARED TIPOCOMANDO
DIM SHARED QUOTAGIRO#, PERCVEL
DIM SHARED FLAGMA
DIM SHARED DSTARVERSION$
DIM SHARED PRG$(512), CODE$(512)
DIM SHARED l
DIM SHARED PROGCAPTURE, PC, EEPRGMAX#
DIM SHARED TIMEOUTSERIAL, TIMEOUTCOMMAND, TIMEOUTEEPROM
DIM SHARED FULLDUPLEX

'**** ASSEGNAZIONE VARIABILI SHARED ***
l = 3                   '* Lingua di default: L=1 italiano, L=2 inglese, L=3 tedesco
BAUD$ = "19200"         '* BAUD RATE di default
COM$ = "COM1"           '* Porta seriale di default
DRIVER$ = "APSPRG"      '* Maschera comandi di default
ADDRESS = 0             '* Indirizzo di default
DSTARVERSION$ = "3.1.1L"  '* Versione programma
TIMEOUTCOMMAND = 2      '* Timeout per comandi seriali (in secondi)
TIMEOUTEEPROM = 20      '* Timeout per comandi EEPROM (in secondi)

EEPRGMAX# = 16          '* Numero massimo di programmi nella EEPROM (8 o 16)
PROGCAPTURE = 99        '* se =99 nessuna acquisizione in corso
PERCVEL = 100           '* percentuale velocit
QUOTAGIRO# = 10000      '* Quota di 1 giro = 100 mm per default *
FULLDUPLEX = 1          '* Se =0 imposta modalit half duplex

CLOSE                   '* chiudi la seriale se aperta
'* apri e chiudi seriale per svuotare il buffer *
OPEN COM$ + ":" + BAUD$ + ",N,8,1,cs,ds,cd" FOR RANDOM AS #1
CLOSE

'* APRI SERIALE CON PARAMETRI DI DEFAULT *
OPEN COM$ + ":" + BAUD$ + ",N,8,1,cs,ds,cd" FOR RANDOM AS #1

FLAGMA = 0
ABORTCOMMAND = 0
SETADDRESS = 0
SWITCHALL = 0
COLORECOM1 = 7          'Colore comandi pari
COLORECOM2 = 3          'Colore comandi dispari

TOGGLECOLOR = 0
COLORECOM = COLORECOM1

COLOR COLORECOM, 1                        ' Imposta il colore dello schermo.
'*Assegnazione KEY per riconoscimento tasti funzione
KEY 1, "F1"
KEY 2, "F2"
KEY 3, "F3"
KEY 4, "F4"
KEY 5, "F5"
KEY 6, "F6"
KEY 7, "F7"
KEY 8, "F8"
KEY 9, "F9"
KEY 10, "FA"
KEY 30, "FB"
KEY 31, "FC"

CLS
IF DRIVER$ = "APS" THEN CALL MascheraAPS
IF DRIVER$ = "ABS" THEN CALL MascheraABS
IF DRIVER$ = "SIO" THEN CALL MascheraSIO
IF DRIVER$ = "APSPRG" THEN CALL MascheraAPSPRG


'* MAIN LOOP *
DO
   IF TOGGLECOLOR = 0 THEN
	TOGGLECOLOR = 1
	COLORECOM = COLORECOM1
   ELSE
	TOGGLECOLOR = 0
	COLORECOM = COLORECOM2
	COLOR COLORECOM2
   END IF

   COLOR COLORECOM

   TIPOCOMANDO = 1           '* comando con risposta *

   PRINT "CMD> ";

   DO
	TastoInput$ = INKEY$
	IF TastoInput$ <> "" THEN
		IF TastoInput$ = "F" THEN
			TastoInput1$ = INKEY$
			IF TastoInput1$ <> "" THEN TastoInput$ = "F" + TastoInput1$
		END IF
		     
		IF LEFT$(TastoInput$, 1) = CHR$(0) THEN
			TastoInput1$ = RIGHT$(TastoInput$, 1)
			IF TastoInput1$ <> "" THEN TastoInput$ = "S" + TastoInput1$
		END IF
		EXIT DO
	END IF
    LOOP

   TastoInput$ = UCASE$(TastoInput$)

   SELECT CASE DRIVER$
	CASE "APS": CALL ApsCommands(TastoInput$)
	CASE "ABS": CALL AbsCommands(TastoInput$)
	CASE "SIO": CALL SioCommands(TastoInput$)
	CASE "APSPRG": CALL ApsPrgCommands(TastoInput$)
   END SELECT

LOOP

END


'**** GESTIONE ERRORI ****

GestioneErrore:
 
  PRINT
  PRINT "Errore"; ERR; "- "; ' alla riga "; ERL
  SELECT CASE ERR
    CASE 57
	IF l = 1 THEN PRINT "Errore di comunicazione "; COM$
	IF l = 2 THEN PRINT "Comunication error"; COM$
	IF l = 3 THEN PRINT "Comunication error"; COM$

	CLOSE                   '* chiudi la seriale se aperta
	'* apri e chiudi seriale per svuotare il buffer *
	'OPEN COM$ + ":" + BAUD$ + ",N,8,1,cs,ds,cd" FOR RANDOM AS #1
	'CLOSE
	'* APRI SERIALE CON PARAMETRI DI DEFAULT *
	OPEN COM$ + ":" + BAUD$ + ",N,8,1,cs,ds,cd" FOR RANDOM AS #1
       
	RESUME NEXT
   
    CASE ELSE
      IF l = 1 THEN PRINT "Errore non previsto, termine del programma."
      IF l = 2 THEN PRINT "Error. End of program."
      IF l = 3 THEN PRINT "Error. End of program."
      END
  END SELECT

REM $STATIC
SUB AbsCommands (TastoInput$)
'* DECODIFICA COMANDI PER ABS *
  
   TIMEOUTSERIAL = TIMEOUTCOMMAND
 
   SELECT CASE TastoInput$
	CASE CHR$(27): CLOSE : VIEW PRINT: COLOR 7, 0: CLS : END
	CASE "FC": ' ** F12 - cambia lingua
		IF l = 1 THEN l = 2 ELSE IF l = 2 THEN l = 3 ELSE IF l = 3 THEN l = 1
		CLS : CALL CambiaMaschera(1): ABORTCOMMAND = 1
	CASE "0": CLS : CALL CambiaMaschera(0): ABORTCOMMAND = 1
	CASE "1": CALL CMDSetSerial:    ABORTCOMMAND = 1
	CASE "2": CALL CMDSetAddr:      ABORTCOMMAND = 1
	CASE "3": Comando$ = CMDReset$(1)
	CASE "4": Comando$ = CMDVMin$(1)
	CASE "5": Comando$ = CMDVMax$(1)
	CASE "6": Comando$ = CMDRampa$(1)
	CASE "7": Comando$ = CMDMovInfinito$(1)
	CASE "8": Comando$ = CMDStopRmp$(1)
	CASE "9": Comando$ = CMDStopImm$(1)
	CASE "A": Comando$ = CMDRitardoSeriale$(1)
	CASE "B": Comando$ = CMDVersioneSoft$(1)
	CASE "C": Comando$ = CMDTipoDrv$(1)
	CASE "D": Comando$ = CMDSetErrSpdABS$(1)
	CASE "E": Comando$ = CMDRampaDec$(1)
   CASE ELSE
	TIPOCOMANDO = 10
	PRINT
   END SELECT

   ABORTCOMMAND = 0
   Comando$ = ""
   TIPOCOMANDO = 1

END SUB

SUB ApsCommands (TastoInput$)

'* DECODIFICA COMANDI PER APS *
  
   TIMEOUTSERIAL = TIMEOUTCOMMAND

   SELECT CASE TastoInput$
	CASE CHR$(27): CLOSE : VIEW PRINT: COLOR 7, 0: CLS : END
	CASE "FC": ' ** F12 - cambia lingua
		IF l = 1 THEN l = 2 ELSE IF l = 2 THEN l = 3 ELSE IF l = 3 THEN l = 1
		CLS : CALL CambiaMaschera(1): ABORTCOMMAND = 1
	CASE "0": CLS : CALL CambiaMaschera(0): ABORTCOMMAND = 1
	CASE "1": CALL CMDSetSerial:    ABORTCOMMAND = 1
	CASE "2": CALL CMDSetAddr:      ABORTCOMMAND = 1
	CASE "3": Comando$ = CMDReset$(1)
	CASE "4": Comando$ = CMDCurrentSet$(1)
	CASE "5": Comando$ = CMDFMin$(1)
	CASE "6": Comando$ = CMDFMax$(1)
	CASE "7": Comando$ = CMDRampa$(1)
	CASE "8": Comando$ = CMDMovRelativo$(1)
	CASE "9": Comando$ = CMDMovAssoluto$(1)
	CASE "A": Comando$ = CMDMovInfinito$(1)
	CASE "B": Comando$ = CMDStartUltimo$(1)
	CASE "C": Comando$ = CMDStop$(1)
	CASE "D": Comando$ = CMDSetHome$(1)
	CASE "E": Comando$ = CMDLetturaPosiz$(1)
	CASE "F": Comando$ = CMDDivisionePasso$(1)
	CASE "G": Comando$ = CMDRiduzioneCorr$(1)
	CASE "H": Comando$ = CMDLivelloInPos$(1)
	CASE "I": Comando$ = CMDRitardoSeriale$(1)
	CASE "J": Comando$ = CMDVersioneSoft$(1)
	CASE "K": Comando$ = CMDTipoDrv$(1)
	CASE "L": Comando$ = CMDZeroAlVolo$(1)
	CASE "M": Comando$ = CMDStatoDrv1$(1)
	CASE "N": Comando$ = CMDStatoDrv2$(1)
	CASE "O": Comando$ = CMDPercVelocita$(1)
	CASE "Q": CALL CMDQuotaGiro:    ABORTCOMMAND = 1
	CASE "R": Comando$ = CMDQuotamm$(1)
	CASE "S": Comando$ = CMDQuotammNoPos$(1)
	CASE "T": Comando$ = CMDStopTrigExt$(1)
	CASE "U": Comando$ = CMDStartTrigExt$(1)
	CASE "V": Comando$ = CMDExtracorsa$(1)
	CASE "W": Comando$ = CMDStopTrigExtOr$(1)
	CASE "X": Comando$ = CMDHomeAbsSwitchall$(1): TIPOCOMANDO = 9'*GO HOME ABS SWITCHALL
	CASE "Y": Comando$ = CMDQuotaInizialeZfly$(1)
	CASE "Z": Comando$ = CMDAzzeramento$(1)
	CASE "+": PERCVEL = PERCVEL + 10: Comando$ = CMDPercVelAuto$(1)
	CASE "-": PERCVEL = PERCVEL - 10: Comando$ = CMDPercVelAuto$(1)
	CASE "/": Comando$ = CMDPassiFrenata$(1)
	CASE "(": Comando$ = CMDPassiActivInPos$(1)
	CASE "?": Comando$ = CMDSerialEcho$(1)
	CASE ")": Comando$ = CMDStepGenNenc$(1)
	CASE "!": Comando$ = CMDAttivaStepOut$(1)
	CASE "%": Comando$ = CMDSmorzamenti$(1)
   CASE ELSE
	TIPOCOMANDO = 10
	PRINT
   END SELECT

   ABORTCOMMAND = 0
   Comando$ = ""
   TIPOCOMANDO = 1
  
   CALL UpdateStatusLine

END SUB

SUB ApsPrgCommands (TastoInput$)
'* DECODIFICA COMANDI PER APS PROGRAMMAZIONE EEPROM*
  
   TIMEOUTSERIAL = TIMEOUTCOMMAND
  
   SELECT CASE TastoInput$
	CASE CHR$(27): CLOSE : VIEW PRINT: COLOR 7, 0: CLS : END
	CASE "F1": Comando$ = PRGCMDStartAcq$(1)
	CASE "F2": Comando$ = PRGCMDStopAcq$(1)
	CASE "F3": TIMEOUTSERIAL = TIMEOUTEEPROM: Comando$ = PRGCMDEdit$(1): ABORTCOMMAND = 1
	CASE "F4": TIMEOUTSERIAL = TIMEOUTEEPROM: Comando$ = PRGCMDErase$(1, 99): ABORTCOMMAND = 1
	CASE "F5": TIMEOUTSERIAL = TIMEOUTEEPROM: Comando$ = PRGCMDEraseAll$(1): ABORTCOMMAND = 1
	CASE "F6": Comando$ = PRGCMDStatus$(1): ABORTCOMMAND = 1
	CASE "F7": Comando$ = PRGCMDRepeat$(1)
	CASE "F8": Comando$ = PRGCMDPausa$(1)
	CASE "F9": Comando$ = PRGCMDTestEeprom$(1): ABORTCOMMAND = 1
	CASE "FA": Comando$ = PRGCMDPrintAll$(1)
	CASE "FB": Comando$ = PRGCMDReadAddr$(1)
	CASE "FC": ' ** F12 - cambia lingua
		IF l = 1 THEN l = 2 ELSE IF l = 2 THEN l = 3 ELSE IF l = 3 THEN l = 1
		CLS : CALL CambiaMaschera(1): ABORTCOMMAND = 1
       
	CASE "0": CLS : CALL CambiaMaschera(0): ABORTCOMMAND = 1
	CASE "1": CALL CMDSetSerial:    ABORTCOMMAND = 1
	CASE "2": CALL CMDSetAddr:      ABORTCOMMAND = 1
	CASE "3": Comando$ = CMDReset$(1)
	CASE "4": Comando$ = CMDCurrentSet$(1)
	CASE "5": Comando$ = CMDFMin$(1)
	CASE "6": Comando$ = CMDFMax$(1)
	CASE "7": Comando$ = CMDRampa$(1)
	CASE "8": Comando$ = CMDMovRelativo$(1)
	CASE "9": Comando$ = CMDMovAssoluto$(1)
	CASE "A": Comando$ = CMDMovInfinito$(1)
	CASE "B": Comando$ = CMDStartUltimo$(1)
	CASE "C": Comando$ = CMDStop$(1)
	CASE "D": Comando$ = CMDSetHome$(1)
	CASE "E": Comando$ = CMDLetturaPosiz$(1)
	CASE "F": Comando$ = CMDDivisionePasso$(1)
	CASE "G": Comando$ = CMDRiduzioneCorr$(1)
	CASE "H": Comando$ = CMDLivelloInPos$(1)
	CASE "I": Comando$ = CMDRitardoSeriale$(1)
	CASE "J": Comando$ = CMDVersioneSoft$(1)
	CASE "K": Comando$ = CMDTipoDrv$(1)
	CASE "L": Comando$ = CMDZeroAlVolo$(1)
	CASE "M": Comando$ = CMDStatoDrv1$(1)
	CASE "N": Comando$ = CMDStatoDrv2$(1)
	CASE "O": Comando$ = CMDPercVelocita$(1)
	CASE "Q": CALL CMDQuotaGiro:    ABORTCOMMAND = 1
	CASE "R": Comando$ = CMDQuotamm$(1)
	CASE "S": Comando$ = CMDQuotammNoPos$(1)
	CASE "T": Comando$ = CMDStopTrigExt$(1)
	CASE "U": Comando$ = CMDStartTrigExt$(1)
	CASE "V": Comando$ = CMDExtracorsa$(1)
	CASE "Z": Comando$ = CMDAzzeramento$(1)
	CASE "W": Comando$ = CMDStopTrigExtOr$(1)
	CASE "X": Comando$ = CMDHomeAbsSwitchall$(1): TIPOCOMANDO = 9'*GO HOME ABS SWITCHALL
	CASE "O": Comando$ = CMDFMaxMOV$(1)
	CASE "Y": Comando$ = CMDQuotaInizialeZfly$(1)
	CASE "+": PERCVEL = PERCVEL + 10: Comando$ = CMDPercVelAuto$(1)
	CASE "-": PERCVEL = PERCVEL - 10: Comando$ = CMDPercVelAuto$(1)
	CASE "/": Comando$ = CMDPassiFrenata$(1)
	CASE "(": Comando$ = CMDPassiActivInPos$(1)
	CASE "?": Comando$ = CMDSerialEcho$(1)
	CASE ")": Comando$ = CMDStepGenNenc$(1)
	CASE "!": Comando$ = CMDAttivaStepOut$(1)
	CASE "": Comando$ = PRGCMDStart$(1)
	CASE "$": Comando$ = PRGCMDStop$(1)
	CASE "%": Comando$ = CMDSmorzamenti$(1)
   CASE ELSE
	TIPOCOMANDO = 10
	PRINT
   END SELECT

   ABORTCOMMAND = 0
   Comando$ = ""
   TIPOCOMANDO = 1
  
   CALL UpdateStatusLine

END SUB

SUB BinToDec (Bin$, ValoreDec)

'*****************************************************
'* Converte una stringa di 8 caratteri (0/1) binaria *
'* in un numero decimale                             *
'*****************************************************

Bin$ = LTRIM$(RTRIM$(Bin$))
'IF LEN(bin$ <> 8) THEN PRINT "ERRORE!": EXIT SUB

bit1 = VAL(MID$(Bin$, 8, 1)) * 1
bit2 = VAL(MID$(Bin$, 7, 1)) * 2
bit3 = VAL(MID$(Bin$, 6, 1)) * 4
bit4 = VAL(MID$(Bin$, 5, 1)) * 8
bit5 = VAL(MID$(Bin$, 4, 1)) * 16
bit6 = VAL(MID$(Bin$, 3, 1)) * 32
bit7 = VAL(MID$(Bin$, 2, 1)) * 64
bit8 = VAL(MID$(Bin$, 1, 1)) * 128

ValoreDec = bit1 + bit2 + bit3 + bit4 + bit5 + bit6 + bit7 + bit8

END SUB

FUNCTION BnbAdd$ (Comando$)

'* Calcolo 2 byte da trasmettere contenente il numero di bytes da inviare
'* e l'indirizzo

BnB = LEN(Comando$)

CALL DecToBin(BnB, Bin$)

BnB$ = RIGHT$(Bin$, 3)

CALL DecToBin(ADDRESS, Bin$)
add$ = RIGHT$(Bin$, 5)

BA$ = BnB$ + add$

'PRINT "---"; BA$; "---"
CALL BinToDec(BA$, Dec)

BnbAdd$ = CHR$(Dec)

END FUNCTION

FUNCTION CalcoloChksum (Comando$)

'* calcolo CHKSUM (ULTIMO BYTE DELLA STRINGA DA INVIARE) *

chk = 0
FOR i = 1 TO LEN(Comando$)
	chk = chk + ASC(MID$(Comando$, i, 1))
NEXT i

chk = chk AND 255       '*CONSIDERO SOLO 1 BYTE

chk = 255 - chk         'COMPLEMENTO

CalcoloChksum = chk

REM PRINT chk, HEX$(chk)

END FUNCTION

SUB CambiaMaschera (a)
VIEW PRINT 12 TO 24      '* Stampa tra le righe 1 e 15.

LOCATE 23, 1:
FOR i = 1 TO 15
	FOR j = 1 TO 20000: NEXT j
	FOR j = 1 TO 20000: NEXT j
	PRINT
NEXT i

IF a = 0 THEN
	'*cambia maschera
	SELECT CASE DRIVER$
		CASE "APS": MascheraABS
		CASE "ABS": MascheraSIO
		CASE "SIO": MascheraAPSPRG
		CASE "APSPRG": MascheraAPS
	END SELECT

	'* Azzero variabili shared visualizzate sulla maschera *
	CORRENTE# = 0
	FMIN = 0
	FMAX# = 0
	RAMPA = 0
ELSE
	'*ristampa la maschera corrente con la nuova lingua
	SELECT CASE DRIVER$
		CASE "APS": MascheraAPS
		CASE "ABS": MascheraABS
		CASE "SIO": MascheraSIO
		CASE "APSPRG": MascheraAPSPRG
	END SELECT


END IF

END SUB

FUNCTION CMDAttivaStepOut$ (send)

'** COMANDO ATTIVAZIONE/DISATTIVAZIONE USCITA STEP-OUT **
IF l = 1 THEN PRINT "Abilita STEP_OUT [0=NO o 1=SI] = ";
IF l = 2 THEN PRINT "Enable STEP_OUT [0=NO o 1=YES] = ";
IF l = 3 THEN PRINT "Enable STEP_OUT [0=NO o 1=YES] = ";

ENASO = SpecialInput#(0, 1, 1)

IF ABORTCOMMAND = 1 THEN EXIT FUNCTION
IF ENASO = 1 THEN ENASO = 255
Comando$ = CHR$(&HB5) + CHR$(ENASO)

CMDAttivaStepOut$ = Comando$
IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

FUNCTION CMDAzzeramento$ (send)
'** COMANDO AZZERAMENTO **
IF l = 1 THEN
	PRINT "Assegnazione ingressi per AZZERAMENTO"
	PRINT "     INGRESSI [4321] [0XXX] = ";
END IF

IF l = 2 THEN
	PRINT "AXIS ZEROING input setting"
	PRINT "     INPUTS  [4321] [0XXX] = ";
END IF

IF l = 3 THEN
	PRINT "Referenzfahrt Eingangs Einst."
	PRINT "     Whlen Sie die Eingnge [4321] [0XXX] = ";
END IF

ZeroIn = SpecialInput#(0, 1110, 4)
IF ABORTCOMMAND = 1 THEN EXIT FUNCTION
ZeroIn$ = RTRIM$(LTRIM$(STR$(ZeroIn)))

IF l = 1 THEN PRINT "     LIVELLI  [4321] [0XXX] = ";
IF l = 2 THEN PRINT "     LEVELS   [4321] [0XXX] = ";
IF l = 3 THEN PRINT "     low/high aktiv [0=LOW oder 1=HIGH] [4321] [0XXX] = ";

ZeroLev = SpecialInput#(0, 1110, 4)
IF ABORTCOMMAND = 1 THEN EXIT FUNCTION
ZeroLev$ = RTRIM$(LTRIM$(STR$(ZeroLev)))

'* Creazione byte con ingressi e livelli per extracorsa *
IF LEN(ZeroLev$) < 4 THEN ZeroLev$ = STRING$(4 - LEN(ZeroLev$), "0") + ZeroLev$
IF LEN(ZeroIn$) < 4 THEN ZeroIn$ = STRING$(4 - LEN(ZeroIn$), "0") + ZeroIn$

byte1$ = ZeroLev$ + ZeroIn$
CALL BinToDec(byte1$, byte1)

Comando$ = CHR$(&HAF) + CHR$(byte1)
CMDAzzeramento$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

FUNCTION CMDCurrentSet$ (send)

'** COMANDO IMPOSTAZIONE CORRENTE - COMANDO A8 **
IF l = 1 THEN PRINT "Corrente [da 0 a 12000 mA] = ";
IF l = 2 THEN PRINT "Current [from 0 to 12000 mA] = ";
IF l = 3 THEN PRINT "Motorstrom [von 0 bis 12000 mA] = ";

CORRENTE# = SpecialInput#(0, 12000, 5)
IF ABORTCOMMAND = 1 THEN EXIT FUNCTION

Comando$ = CHR$(&HA8) + CHR$(CORRENTE# \ 256) + CHR$(CORRENTE# MOD 256)
CMDCurrentSet$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

FUNCTION CMDDivisionePasso$ (send)

'** COMANDO IMPOSTAZIONE DIVISIONE PASSO **

IF l = 1 THEN PRINT "Risoluzione [0=1/1, 1=1/2, 2=1/4, 3=1/8, 4=1/16 di passo] = ";
IF l = 2 THEN PRINT "Resolution [0=1/1, 1=1/2, 2=1/4, 3=1/8, 4=1/16 of step] = ";
IF l = 3 THEN PRINT "Motorschrittauflsung [0=1/1, 1=1/2, 2=1/4, 3=1/8, 4=1/16] = ";

DIVPASSO = SpecialInput#(0, 99, 2)
IF ABORTCOMMAND = 1 THEN EXIT FUNCTION

Comando$ = CHR$(&H26) + CHR$(DIVPASSO)
CMDDivisionePasso$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

FUNCTION CMDExtracorsa$ (send)

'** COMANDO SET EXTRACORSA **
IF l = 1 THEN
	PRINT "Assegnazione ingressi EXTRACORSA"
	PRINT "     INGRESSI [4321] [0XXX] = ";
END IF

IF l = 2 THEN
	PRINT "EXTRA-SWITCH input setting"
	PRINT "     INPUTS   [4321] [0XXX] = ";
END IF

IF l = 3 THEN
	PRINT "Whlen Sie die Endschalter Eingnge (bis 2 Stck)"
	PRINT "     Eingnge   [4321] [0XXX] = ";
END IF

ZeroIn = SpecialInput#(0, 1110, 4)
IF ABORTCOMMAND = 1 THEN EXIT FUNCTION
ZeroIn$ = RTRIM$(LTRIM$(STR$(ZeroIn)))

IF l = 1 THEN PRINT "     LIVELLI  [4321] [0XXX] = ";
IF l = 2 THEN PRINT "     LEVELS   [4321] [0XXX] = ";
IF l = 3 THEN PRINT "     High/low aktiv  [4321] [0XXX] = ";

ZeroLev = SpecialInput#(0, 1110, 4)
IF ABORTCOMMAND = 1 THEN EXIT FUNCTION
ZeroLev$ = RTRIM$(LTRIM$(STR$(ZeroLev)))

'* Creazione byte con ingressi e livelli per extracorsa *
IF LEN(ZeroLev$) < 4 THEN ZeroLev$ = STRING$(4 - LEN(ZeroLev$), "0") + ZeroLev$
IF LEN(ZeroIn$) < 4 THEN ZeroIn$ = STRING$(4 - LEN(ZeroIn$), "0") + ZeroIn$

byte1$ = ZeroLev$ + ZeroIn$
CALL BinToDec(byte1$, byte1)

Comando$ = CHR$(&HB0) + CHR$(byte1)
CMDExtracorsa$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

FUNCTION CMDFMax$ (send)
'** COMANDO IMPOSTAZIONE FREQUENZA MINIMA **
IF l = 1 THEN PRINT "Frequenza massima [da 0 a 20000 Hz] = ";
IF l = 2 THEN PRINT "Maximum frequency [from 0 to 20000 Hz] = ";
IF l = 3 THEN PRINT "Max. Frequenz [von 0 bis 20000 Hz] = ";

FMAX# = SpecialInput#(0, 65535, 6)
IF ABORTCOMMAND = 1 THEN EXIT FUNCTION

Comando$ = CHR$(&H21) + CHR$(FMAX# \ 256#) + CHR$(FMAX# MOD 256#)
CMDFMax$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

FUNCTION CMDFMaxMOV$ (send)

'* COMANDO NON IMPLEMENTATO. Cambiare il codice 0xB2  la quota iniziale zfly *

'** COMANDO IMPOSTAZIONE FREQUENZA MASSIMA IN MOVIMENTO **
IF l = 1 THEN PRINT "Frequenza massima in movmento [da 0 a 20000 Hz] = ";
IF l = 2 THEN PRINT "Maximum frequency on the fly [from 0 to 20000 Hz] = ";
IF l = 3 THEN PRINT "Maximum frequency on the fly [from 0 to 20000 Hz] = ";

FMAX = SpecialInput#(0, 90000, 5)

IF ABORTCOMMAND = 1 THEN EXIT FUNCTION

Comando$ = CHR$(&HB2) + CHR$(FMAX \ 256) + CHR$(FMAX MOD 256)
CMDFMaxMOV$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

FUNCTION CMDFMin$ (send)
'** COMANDO IMPOSTAZIONE FREQUENZA MINIMA **
IF l = 1 THEN PRINT "Frequenza minima [da 0 a 10000 Hz] = ";
IF l = 2 THEN PRINT "Minimum frequency [from 0 to 10000 Hz] = ";
IF l = 3 THEN PRINT "Min. Frequenz [von 0 bis 10000 Hz] (Start/Stop-Frequenz) = ";

FMIN = SpecialInput#(0, 90000, 5)

IF ABORTCOMMAND = 1 THEN EXIT FUNCTION

Comando$ = CHR$(&H20) + CHR$(FMIN \ 256) + CHR$(FMIN MOD 256)
CMDFMin$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

FUNCTION CMDHomeAbsSwitchall$ (send)
'** POSIZIONA TUTTI GLI ASSI ALLA POSIZIONE ASSOLUTA 0 **
IF l = 1 THEN PRINT "Posizionamento assoluto a zero (SWITCHALL)"
IF l = 2 THEN PRINT "Go home "
IF l = 3 THEN PRINT "Nullpunktfahrt"

Comando$ = CHR$(&H30) + CHR$(0) + CHR$(0) + CHR$(0) + CHR$(0)

CMDHomeAbsSwitchall$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

FUNCTION CMDLetturaPosiz$ (send)
IF l = 1 THEN PRINT "Lettura posizione attuale"
IF l = 2 THEN PRINT "Reading present position"
IF l = 3 THEN PRINT "Anzeige der aktuellen Position"

Comando$ = CHR$(&H12)
CMDLetturaPosiz$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 8)
  
IF RECEIVE$ <> "" THEN
   aa = LEN(RECEIVE$)
   Posizione# = ASC(MID$(RECEIVE$, aa - 1, 1)) + ASC(MID$(RECEIVE$, aa - 2, 1)) * 256# + ASC(MID$(RECEIVE$, aa - 3, 1)) * 256# * 256# + ASC(MID$(RECEIVE$, aa - 4, 1)) * 256# * 256# * 256#
   IF Posizione# > 2147483647# THEN Posizione# = -(2147483648# * 2 - Posizione#)
   IF l = 1 THEN PRINT "     Posizione Attuale ="; Posizione#
   IF l = 2 THEN PRINT "     Present position ="; Posizione#
   IF l = 3 THEN PRINT "     Present position ="; Posizione#
END IF

END FUNCTION

FUNCTION CMDLivelloInPos$ (send)

'** COMANDO IMPOSTAZIONE LIVELLO USCITA IN POSIZIONE **
IF l = 1 THEN PRINT "Livello uscita 'IN POSIZIONE' [0=BASSO o 1=ALTO] = ";
IF l = 2 THEN PRINT "'IN POSITION' Output level [0=LOW or 1=HIGH] = ";
IF l = 3 THEN PRINT "Whlen Sie Ausgangsmeldung 'IN POSITION'": PRINT "     low/high aktiv [0=LOW oder 1=HIGH] = ";

LEV = SpecialInput#(0, 1, 1)
IF ABORTCOMMAND = 1 THEN EXIT FUNCTION
IF LEV = 1 THEN LEV = &HFF

Comando$ = CHR$(&H2B) + CHR$(LEV)
CMDLivelloInPos$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

FUNCTION CMDMovAssoluto$ (send)
'** COMANDO POSIZIONAMENTO ASSOLUTO **
IF l = 1 THEN PRINT "Posizionamento assoluto = ";
IF l = 2 THEN PRINT "Absolute positioning = ";
IF l = 3 THEN PRINT "Eingabe absoluter Weg in 1/128 Schritte ( 25600 = 1 Umdr. ) = ";

MOVABS# = SpecialInput#(-2147483647#, 2147483647#, 10)
IF ABORTCOMMAND = 1 THEN EXIT FUNCTION


IF (MOVABS# < 0) THEN
	MOVABS# = ABS(MOVABS#) - 1: QuotaNegativa = 1
ELSE
	QuotaNegativa = 0
END IF

V# = MOVABS#

MOVABS1# = V# \ &H1000000
V# = V# MOD &H1000000

MOVABS2# = V# \ &H10000
V# = V# MOD &H10000

MOVABS3# = V# \ &H100
V# = V# MOD &H100

MOVABS4# = V#


IF QuotaNegativa = 1 THEN
   MOVABS1# = &HFF - MOVABS1#
   MOVABS2# = &HFF - MOVABS2#
   MOVABS3# = &HFF - MOVABS3#
   MOVABS4# = &HFF - MOVABS4#
END IF

Comando$ = CHR$(&H30) + CHR$(MOVABS1#) + CHR$(MOVABS2#) + CHR$(MOVABS3#) + CHR$(MOVABS4#)
CMDMovAssoluto$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

FUNCTION CMDMovInfinito$ (send)

'** COMANDO MOVIMENTO INFINITO **
IF l = 1 THEN PRINT "Movimento infinito [0=CW o 1=CCW] = ";
IF l = 2 THEN PRINT "Infinite motion [0=CW or 1=CCW] = ";
IF l = 3 THEN PRINT "Dauerlauf [0=Uhrzeiger oder 1=Gegenuhrzeiger] = ";

MOVINF = SpecialInput#(0, 1, 1)
IF ABORTCOMMAND = 1 THEN EXIT FUNCTION
IF MOVINF = 1 THEN MOVINF = &HFF

Comando$ = CHR$(&H32) + CHR$(MOVINF)
CMDMovInfinito$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

FUNCTION CMDMovRelativo$ (send)
'** COMANDO POSIZIONAMENTO RELATIVO **
IF l = 1 THEN PRINT "Posizionamento relativo = ";
IF l = 2 THEN PRINT "Relative positioning = ";
IF l = 3 THEN PRINT "Eingabe relativer Weg in 1/128 Schritte ( 25600 = 1 Umdr. ) = ";


MOVREL# = SpecialInput#(-2147483647#, 2147483647#, 10)
IF ABORTCOMMAND = 1 THEN EXIT FUNCTION

IF (MOVREL# < 0) THEN
	MOVREL# = ABS(MOVREL#) - 1: QuotaNegativa = 1
ELSE
	QuotaNegativa = 0
END IF

V# = MOVREL#

MOVREL1# = V# \ &H1000000
V# = V# MOD &H1000000

MOVREL2# = V# \ &H10000
V# = V# MOD &H10000

MOVREL3# = V# \ &H100
V# = V# MOD &H100

MOVREL4# = V#


IF QuotaNegativa = 1 THEN
   MOVREL1# = &HFF - MOVREL1#
   MOVREL2# = &HFF - MOVREL2#
   MOVREL3# = &HFF - MOVREL3#
   MOVREL4# = &HFF - MOVREL4#
END IF

Comando$ = CHR$(&H31) + CHR$(MOVREL1#) + CHR$(MOVREL2#) + CHR$(MOVREL3#) + CHR$(MOVREL4#)
CMDMovRelativo$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

FUNCTION CMDPassiActivInPos$ (send)
'** COMANDO IMPOSTAZIONE PASSI DI FRENATA **
IF l = 1 THEN PRINT "N. passi pre-attivazione uscita IN_POS [da 0 a 2147483647] = ";
IF l = 2 THEN PRINT "Step number of 'IN-POS' pre-activation [from 0 to 2147483647] = ";
IF l = 3 THEN PRINT "Eingabe Weg zur Druckmarkenunterdrckung in 1/128 Schritte": PRINT " ( 25600 = 1 Umdr. ) = ";

StepInPos# = SpecialInput#(0, 2147483647#, 10)
IF ABORTCOMMAND = 1 THEN EXIT FUNCTION


V# = StepInPos#

StepInPos1# = V# \ &H1000000
V# = V# MOD &H1000000

StepInPos2# = V# \ &H10000
V# = V# MOD &H10000

StepInPos3# = V# \ &H100
V# = V# MOD &H100

StepInPos4# = V#

Comando$ = CHR$(&HB4) + CHR$(StepInPos1#) + CHR$(StepInPos2#) + CHR$(StepInPos3#) + CHR$(StepInPos4#)
CMDPassiActivInPos$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

FUNCTION CMDPassiFrenata$ (send)

'** COMANDO IMPOSTAZIONE PASSI DI FRENATA **
IF l = 1 THEN PRINT "Passi di frenata [da 0 a 2147483647] = ";
IF l = 2 THEN PRINT "Brake steps [from 0 to 2147483647] = ";
IF l = 3 THEN PRINT "Brake steps [from 0 to 2147483647] = ";

StepFrenata# = SpecialInput#(0, 2147483647#, 10)

IF ABORTCOMMAND = 1 THEN EXIT FUNCTION

V# = StepFrenata#

StepFrenata1# = V# \ &H1000000
V# = V# MOD &H1000000

StepFrenata2# = V# \ &H10000
V# = V# MOD &H10000

StepFrenata3# = V# \ &H100
V# = V# MOD &H100

StepFrenata4# = V#


Comando$ = CHR$(&HB3) + CHR$(StepFrenata1#) + CHR$(StepFrenata2#) + CHR$(StepFrenata3#) + CHR$(StepFrenata4#)
CMDPassiFrenata$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

FUNCTION CMDPercVelAuto$ (send)

'* Cambia velocit con comando 0xAD con tasti + e - vedi SUB ComandiAPD *
IF PERCVEL < 0 THEN PERCVEL = 0
IF PERCVEL > 255 THEN PERCVEL = 255

IF l = 1 THEN PRINT "La Velocit attuale corrisponde al"; PERCVEL; "% della velocit impostata"
IF l = 2 THEN PRINT "The speed is"; PERCVEL; "% of setting speed"
IF l = 3 THEN PRINT "The speed is"; PERCVEL; "% of setting speed"

Comando$ = CHR$(&HAD) + CHR$(PERCVEL)
CMDPercVelAuto$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)


END FUNCTION

FUNCTION CMDPercVelocita$ (send)

'** COMANDO IMPOSTAZIONE PERCENTUALE VELOCITA' **
IF l = 1 THEN PRINT "Percentuale velocit [da 10% a 200%] = "; : PERCVEL = SpecialInput#(0, 255, 3)
IF l = 2 THEN PRINT "Speed % [from 10% to 200%] = "; : PERCVEL = SpecialInput#(0, 255, 3)
IF l = 3 THEN PRINT "Drehzahlnderung in % [von 10% bis 200%] = "; : PERCVEL = SpecialInput#(0, 255, 3)

IF ABORTCOMMAND = 1 THEN EXIT FUNCTION
Comando$ = CHR$(&HAD) + CHR$(PERCVEL)
CMDPercVelocita$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

SUB CMDQuotaGiro
'** IMPOSTAZIONE DELLA QUOTA IN mm **
IF l = 1 THEN PRINT "Quota di 1 giro [centesimi di mm] = ";
IF l = 2 THEN PRINT "Quote/revolution [1/100 of mm] = ";
IF l = 3 THEN PRINT "Eingabe Weg/Umdrehung": PRINT "     (z.B. bei Steigung 10mm (10/1)x(1/100)=1000) = ";

QUOTAGIRO# = SpecialInput#(0, 2147483647#, 10)
IF ABORTCOMMAND = 1 THEN EXIT SUB

END SUB

FUNCTION CMDQuotaInizialeZfly$ (send)
'** COMANDO IMPOSTAZIONE QUOTA INIZIALE ZERO AL VOLO **
IF l = 1 THEN PRINT "Quota iniziale zero al volo = ";
IF l = 2 THEN PRINT "Zero at flight start quote = ";
IF l = 3 THEN PRINT "Weg in Schritten in der Druckmarke unterdrckt wird": PRINT "     (25600 = 1 Umdr.) = ";

QSTART# = SpecialInput#(-2147483647#, 2147483647#, 10)
IF ABORTCOMMAND = 1 THEN EXIT FUNCTION

IF (QSTART# < 0) THEN
	QSTART# = ABS(QSTART#) - 1: QuotaNegativa = 1
ELSE
	QuotaNegativa = 0
END IF

V# = QSTART#

QSTART1# = V# \ &H1000000
V# = V# MOD &H1000000

QSTART2# = V# \ &H10000
V# = V# MOD &H10000

QSTART3# = V# \ &H100
V# = V# MOD &H100

QSTART4# = V#


IF QuotaNegativa = 1 THEN
   QSTART1# = &HFF - QSTART1#
   QSTART2# = &HFF - QSTART2#
   QSTART3# = &HFF - QSTART3#
   QSTART4# = &HFF - QSTART4#
END IF

Comando$ = CHR$(&HB2) + CHR$(QSTART1#) + CHR$(QSTART2#) + CHR$(QSTART3#) + CHR$(QSTART4#)
CMDQuotaInizialeZfly$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

FUNCTION CMDQuotamm$ (send)
'** IMPOSTAZIONE DELLA QUOTA IN mm **
IF l = 1 THEN PRINT "Posizionamento relativo in mm = ";
IF l = 2 THEN PRINT "Relative positioning [mm] = ";
IF l = 3 THEN PRINT "Eingabe relativer Weg in mm = ";

QUOTAREL# = SpecialInput#(-2147483647#, 2147483647#, 10)

IF ABORTCOMMAND = 1 THEN EXIT FUNCTION

IF QUOTAREL# < 0 THEN
	QUOTAREL# = ABS(QUOTAREL#): QuotaNegativa = 1
ELSE
	QuotaNegativa = 0
END IF

'* Conversione tra quota in mm e 1/128 di passo *
MOVREL# = QUOTAREL# * 100 / QUOTAGIRO# * 25600#

IF QuotaNegativa = 1 THEN MOVREL# = -MOVREL# - 1


IF (MOVREL# < 0) THEN
	MOVREL# = ABS(MOVREL#) - 1: QuotaNegativa = 1
ELSE
	QuotaNegativa = 0
END IF

IF l = 1 THEN PRINT "     Quota relativa in 1/128 di passo =";
IF l = 2 THEN PRINT "     Relative quote 1/128 of steps =";
IF l = 3 THEN PRINT "     Relativer Weg in 1/128 Schritte =";

IF QuotaNegativa = 1 THEN PRINT " -";  ELSE PRINT " ";
MR# = INT(MOVREL#)
IF (MOVREL# - MR#) > .5 THEN MR# = MR# + 1
PRINT LTRIM$(STR$(MR#))


V# = MOVREL#

MOVREL1# = V# \ &H1000000
V# = V# MOD &H1000000

MOVREL2# = V# \ &H10000
V# = V# MOD &H10000

MOVREL3# = V# \ &H100
V# = V# MOD &H100

MOVREL4# = V#


IF QuotaNegativa = 1 THEN
   MOVREL1# = &HFF - MOVREL1#
   MOVREL2# = &HFF - MOVREL2#
   MOVREL3# = &HFF - MOVREL3#
   MOVREL4# = &HFF - MOVREL4#
END IF

Comando$ = CHR$(&H31) + CHR$(MOVREL1#) + CHR$(MOVREL2#) + CHR$(MOVREL3#) + CHR$(MOVREL4#)
CMDQuotamm$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

FUNCTION CMDQuotammNoPos$ (send)

'** COMANDO IMPOSTAZIONE QUOTA RELATIVA IN mm SENZA ESEGUIRE IL POSIZIONAMENTO **
IF l = 1 THEN PRINT "Posizionamento relativo in mm senza esecuzione = ";
IF l = 2 THEN PRINT "Relative positioning [mm] no exec = ";
IF l = 3 THEN PRINT "Eingabe relativer Weg in mm ohne Ausfhrung = ";

QUOTAREL# = SpecialInput#(-2147483647#, 2147483647#, 10)
IF ABORTCOMMAND = 1 THEN EXIT FUNCTION

IF QUOTAREL# < 0 THEN
	QUOTAREL# = ABS(QUOTAREL#): QuotaNegativa = 1
ELSE
	QuotaNegativa = 0
END IF

'* Conversione tra quota in mm e 1/128 di passo *
MOVREL# = QUOTAREL# * 100 / QUOTAGIRO# * 25600#

IF QuotaNegativa = 1 THEN MOVREL# = -MOVREL# - 1


IF (MOVREL# < 0) THEN
	MOVREL# = ABS(MOVREL#) - 1: QuotaNegativa = 1
ELSE
	QuotaNegativa = 0
END IF

IF l = 1 THEN PRINT "     Quota relativa in 1/128 di passo =";
IF l = 2 THEN PRINT "     Relative quote 1/128 of steps =";
IF l = 3 THEN PRINT "     Relativer Weg in 1/128 Schritte =";

IF QuotaNegativa = 1 THEN PRINT " -";  ELSE PRINT " ";
MR# = INT(MOVREL#)
IF (MOVREL# - MR#) > .5 THEN MR# = MR# + 1
PRINT LTRIM$(STR$(MR#))


V# = MOVREL#

MOVREL1# = V# \ &H1000000
V# = V# MOD &H1000000

MOVREL2# = V# \ &H10000
V# = V# MOD &H10000

MOVREL3# = V# \ &H100
V# = V# MOD &H100

MOVREL4# = V#


IF QuotaNegativa = 1 THEN
   MOVREL1# = &HFF - MOVREL1#
   MOVREL2# = &HFF - MOVREL2#
   MOVREL3# = &HFF - MOVREL3#
   MOVREL4# = &HFF - MOVREL4#
END IF

Comando$ = CHR$(&HAA) + CHR$(MOVREL1#) + CHR$(MOVREL2#) + CHR$(MOVREL3#) + CHR$(MOVREL4#)
CMDQuotammNoPos$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

FUNCTION CMDRampa$ (send)

'** COMANDO IMPOSTAZIONE RAMPA **
IF l = 1 THEN PRINT "Rampa [da 0 a 255 cS per 10kHz] = ";
IF l = 2 THEN PRINT "Ramp [from 0 to 255 cS per 10kHz] = ";
IF l = 3 THEN PRINT "Eingabe Beschleunigungszeit [von 0 bis 255 cS auf 10kHz] = ";

RAMPA = SpecialInput#(0, 255, 3)
IF ABORTCOMMAND = 1 THEN EXIT FUNCTION

Comando$ = CHR$(&H22) + CHR$(RAMPA)
CMDRampa$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)


END FUNCTION

FUNCTION CMDRampaDec$ (send)

'** COMANDO IMPOSTAZIONE RAMPA **
IF l = 1 THEN PRINT "Rampa di decelerazione [da 0 a 255 cS per 10kHz] = ";
IF l = 2 THEN PRINT "Deceleration ramp [from 0 to 255 cS per 10kHz] = ";
IF l = 3 THEN PRINT "Deceleration ramp [from 0 to 255 cS per 10kHz] = ";

RAMPA = SpecialInput#(0, 255, 3)
IF ABORTCOMMAND = 1 THEN EXIT FUNCTION

Comando$ = CHR$(&H24) + CHR$(RAMPADEC)
CMDRampaDec$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

FUNCTION CMDReadAnin1$ (send)

'** READ INGRESSO ANALOGICO 1 **
IF l = 1 THEN PRINT "Lettura ingresso analogico 1"
IF l = 2 THEN PRINT "Read analog in 1"
IF l = 3 THEN PRINT "Read analog in 1"

Comando$ = CHR$(&HC1)
CMDReadAnin1$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 6)
  
IF RECEIVE$ <> "" THEN
   aa = LEN(RECEIVE$)
   AnH = ASC(MID$(RECEIVE$, aa - 2, 1))
   AnL = ASC(MID$(RECEIVE$, aa - 1, 1))
   Analog = AnH * 256 + AnL
   IF l = 1 THEN PRINT "     Ingresso analogico 1 = "; Analog
   IF l = 2 THEN PRINT "     Analog input 1 = "; Analog
   IF l = 3 THEN PRINT "     Analog input 1 = "; Analog

END IF

END FUNCTION

FUNCTION CMDReadAnin2$ (send)

'** READ INGRESSO ANALOGICO 2 **
'** READ INGRESSO ANALOGICO 1 **
IF l = 1 THEN PRINT "Lettura ingresso analogico 2"
IF l = 2 THEN PRINT "Read analog in 2"
IF l = 3 THEN PRINT "Read analog in 2"

Comando$ = CHR$(&HC2)
CMDReadAnin2$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 6)
 
IF RECEIVE$ <> "" THEN
   aa = LEN(RECEIVE$)
   AnH = ASC(MID$(RECEIVE$, aa - 2, 1))
   AnL = ASC(MID$(RECEIVE$, aa - 1, 1))
   Analog = AnH * 256 + AnL
   IF l = 1 THEN PRINT "     Ingresso analogico 2 = "; Analog
   IF l = 2 THEN PRINT "     Analog input 2 = "; Analog
   IF l = 3 THEN PRINT "     Analog input 2 = "; Analog
END IF

END FUNCTION

FUNCTION CMDReadInSio$ (send)

'** READ INGRESSI DIGITALI SIO **
IF l = 1 THEN PRINT "Lettura ingressi digitali"
IF l = 2 THEN PRINT "Read digital inputs"
IF l = 3 THEN PRINT "Read digital inputs"

Comando$ = CHR$(&HC0)
CMDReadInSio$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 5)
 
IF RECEIVE$ <> "" THEN
   aa = LEN(RECEIVE$)
   Ingressi = ASC(MID$(RECEIVE$, aa - 1, 1))
   CALL DecToBin(Ingressi, Bin$)
   IF l = 1 THEN PRINT "     Ingressi attivati = "; Bin$
   IF l = 2 THEN PRINT "     Active inputs = "; Bin$
   IF l = 3 THEN PRINT "     Active inputs = "; Bin$

END IF

END FUNCTION

FUNCTION CMDReset$ (send)

IF l = 1 THEN PRINT "Reset azionamento"
IF l = 2 THEN PRINT "Drive reset"
IF l = 3 THEN PRINT "Endstufen Reset"

Comando$ = CHR$(&H1)     '* Reset
CMDReset$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

FUNCTION CMDRiduzioneCorr$ (send)

'** COMANDO RIDUZIONE CORRENTE **
IF l = 1 THEN PRINT "Tempo intervento riduzione [da 0 a 63 x 32ms] = ";
IF l = 2 THEN PRINT "Reduction time [from 0 to 63 x 32ms] = ";
IF l = 3 THEN
	PRINT "Zeiteingabe fr Stromreduzierung im Stillstand, nach dieser Zeit"
	PRINT "     wird der Motorstrom reduziert [von 0 bis 63 x 32ms] = ";
END IF

TRID = SpecialInput#(0, 63, 2)
IF ABORTCOMMAND = 1 THEN EXIT FUNCTION
IF l = 1 THEN PRINT "     Percentuale di riduzione [0=100%, 1=NO RID, 2=25%, 3=50%] = ";
IF l = 2 THEN PRINT "     Reduction mode [0=100%, 1=NO RED, 2=25%, 3=50%] = ";
IF l = 3 THEN PRINT "     Stillstandsstromabsenkung auf [0=100%, 1=ohne, 2=25%, 3=50%] = ";

PRID = SpecialInput#(0, 3, 1)
IF ABORTCOMMAND = 1 THEN EXIT FUNCTION

CALL DecToBin(TRID, TRIDBIN$)
CALL DecToBin(PRID, PRIDBIN$)

ByteRid$ = RIGHT$(PRIDBIN$, 2) + RIGHT$(TRIDBIN$, 6)

'PRINT ByteRid$
CALL BinToDec(ByteRid$, ByteRid)

Comando$ = CHR$(&H27) + CHR$(ByteRid)
CMDRiduzioneCorr$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

FUNCTION CMDRitardoSeriale$ (send)

'** COMANDO IMPOSTAZIONE RITARDO SERIALE **
IF l = 1 THEN PRINT "Ritardo risposta seriale [da 0 a 255 cS per 10kHz] = ";
IF l = 2 THEN PRINT "Serial delay [from 0 to 255 cS per 10kHz] = ";
IF l = 3 THEN PRINT "Eingabe Zeitverzgerung [von 0 bis 255 cS auf 10kHz] = ";

RITSER = SpecialInput#(0, 255, 3)
IF ABORTCOMMAND = 1 THEN EXIT FUNCTION

Comando$ = CHR$(&H28) + CHR$(RITSER)
CMDRitardoSeriale$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

FUNCTION CMDSerialEcho$ (send)

'** COMANDO IMPOSTAZIONE ECHO SU SERIALE **
IF l = 1 THEN PRINT "Echo su seriale [0=NO o 1=SI] = ";
IF l = 2 THEN PRINT "Serial echo [0=NO o 1=YES] = ";
IF l = 3 THEN PRINT "Serial echo [0=NO o 1=YES] = ";

ECHO = SpecialInput#(0, 1, 1)
IF ECHO = 1 THEN ECHO = 255
IF ABORTCOMMAND = 1 THEN EXIT FUNCTION

Comando$ = CHR$(&HFF) + CHR$(ECHO)
CMDSerialEcho$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

SUB CMDSetAddr

'** SUB IMPOSTAZIONE ADDRESS **
OldSetaddress = SETADDRESS
OldSwitchall = SWITCHALL
OldAddr = ADDRESS

SETADDRESS = 1
SWITCHALL = 0

IF l = 1 THEN PRINT "Indirizzo Azionamento": PRINT "     [da 0 a 31, A=SWITCHALL, M=MULTIADDRESS] = ";
IF l = 2 THEN PRINT "Drive address": PRINT "     [from 0 to 31, A=SWITCHALL, M=MULTIADDRESS] = ";
IF l = 3 THEN PRINT "Einstellung Endstufenadresse": PRINT "     [von 0 bis 31, A=SWITCHALL, M=MULTIADDRESS] = ";

ADDRESS = SpecialInput#(0, 31, 2)
SETADDRESS = 0

IF ABORTCOMMAND = 1 THEN
	SETADDRESS = OldSetaddress
	SWITCHALL = OldSwitchall
	ADDRESS = OldAddr
	EXIT SUB
END IF

'* Azzero variabili shared visualizzate sulla maschera se cambio indirizzo *
IF OldAddr <> ADDRESS OR SWITCHALL <> 0 THEN
	CORRENTE# = 0
	FMIN = 0
	FMAX# = 0
	RAMPA = 0
END IF

CALL UpdateStatusLine

END SUB

FUNCTION CMDSetAnout1$ (send)
'** COMANDO SET USCITA ANALOGICA 1 **

IF l = 1 THEN PRINT "Set uscita analogica 1 [0-255] = ";
IF l = 2 THEN PRINT "Analog out 1 setting [0-255] = ";
IF l = 3 THEN PRINT "Analog out 1 setting [0-255] = ";

anout1 = SpecialInput#(0, 255, 3)
IF ABORTCOMMAND = 1 THEN EXIT FUNCTION
IF MOVINF = 1 THEN MOVINF = &HFF

Comando$ = CHR$(&HC4) + CHR$(anout1)
CMDSetAnout1$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

FUNCTION CMDSetAnout2$ (send)
'** COMANDO SET USCITA ANALOGICA 1 **

IF l = 1 THEN PRINT "Set uscita analogica 2 [0-255] = ";
IF l = 2 THEN PRINT "Analog out 2 setting [0-255] = ";
IF l = 3 THEN PRINT "Analog out 2 setting [0-255] = ";

anout2 = SpecialInput#(0, 255, 3)
IF ABORTCOMMAND = 1 THEN EXIT FUNCTION
IF MOVINF = 1 THEN MOVINF = &HFF

Comando$ = CHR$(&HC5) + CHR$(anout2)
CMDSetAnout2$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

FUNCTION CMDSetErrSpdABS$ (send)

'** COMANDO IMPOSTAZIONE PERCENTUALE DI ERRORE PER CORREZIONE VELOCITA' **
IF l = 1 THEN PRINT "Percentuale errore di velocit [da 0 a 255 cS per 10kHz] = ";
IF l = 2 THEN PRINT "Error of speed correction [from 0 to 255 cS per 10kHz] = ";
IF l = 3 THEN PRINT "Error of speed correction [from 0 to 255 cS auf 10kHz] = ";

ERSPEED = SpecialInput#(0, 255, 3)
IF ABORTCOMMAND = 1 THEN EXIT FUNCTION

Comando$ = CHR$(&HAA) + CHR$(ERSPEED)
CMDSetErrSpdABS$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

FUNCTION CMDSetHome$ (send)
'** IMPOSTAZIONE POSIZIONE DI HOME **
IF l = 1 THEN PRINT "Posizione di home = ";
IF l = 2 THEN PRINT "Home position = ";
IF l = 3 THEN PRINT "Nullpunkt einstellen auf (25600 = 1 Umdr.) = ";

HOMEPOS# = SpecialInput#(-2147483647#, 2147483647#, 10)
IF ABORTCOMMAND = 1 THEN EXIT FUNCTION

IF (HOMEPOS# < 0) THEN
	HOMEPOS# = ABS(HOMEPOS#) - 1: QuotaNegativa = 1
ELSE
	QuotaNegativa = 0
END IF

V# = HOMEPOS#

HOMEPOS1# = V# \ &H1000000
V# = V# MOD &H1000000

HOMEPOS2# = V# \ &H10000
V# = V# MOD &H10000

HOMEPOS3# = V# \ &H100
V# = V# MOD &H100

HOMEPOS4# = V#


IF QuotaNegativa = 1 THEN
   HOMEPOS1# = &HFF - HOMEPOS1#
   HOMEPOS2# = &HFF - HOMEPOS2#
   HOMEPOS3# = &HFF - HOMEPOS3#
   HOMEPOS4# = &HFF - HOMEPOS4#
END IF

Comando$ = CHR$(&H23) + CHR$(HOMEPOS1#) + CHR$(HOMEPOS2#) + CHR$(HOMEPOS3#) + CHR$(HOMEPOS4#)
CMDSetHome$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

FUNCTION CMDSetOut$ (send)

'* COMANDO per settare le uscite digitali *
IF l = 1 THEN
	PRINT "Attivazione uscite"
	PRINT "     USCITE [---654321] [000XXXXXX] = ";
END IF

IF l = 2 THEN
	PRINT "Setting outputs"
	PRINT "     OUTPUTS [---654321] [000XXXXXX] = ";
END IF

IF l = 3 THEN
	PRINT "Setting outputs"
	PRINT "     OUTPUTS [---654321] [000XXXXXX] = ";
END IF

SOuts# = SpecialInput#(0, 111111000#, 9)

IF ABORTCOMMAND = 1 THEN EXIT FUNCTION
SOuts$ = RTRIM$(LTRIM$(STR$(SOuts#)))


'* Completamento byte incompleto *
IF LEN(SOuts$) < 8 THEN SOuts$ = STRING$(8 - LEN(SOuts$), "0") + SOuts$

byte1$ = SOuts$
CALL BinToDec(byte1$, byte1)

Comando$ = CHR$(&HC3) + CHR$(byte1)
CMDSetOut$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

SUB CMDSetSerial

'** SUB IMPOSTAZIONE INTERFACCIA SERIALE E BAUD RATE **

IF l = 1 THEN PRINT "Interfaccia Seriale  [1=COM1, 2=COM2] = ";
IF l = 2 THEN PRINT "Serial interface     [1=COM1, 2=COM2] = ";
IF l = 3 THEN PRINT "Whle serielle Schnittstelle [1=COM1, 2=COM2] = ";

IntSer = SpecialInput#(1, 2, 1)

IF ABORTCOMMAND = 1 THEN EXIT SUB
IF IntSer = 1 THEN COM$ = "COM1"
IF IntSer = 2 THEN COM$ = "COM2"

PRINT "     Baud Rate           [1=9600, 2=19200] = "; : BAUD = SpecialInput#(1, 2, 1)
IF ABORTCOMMAND = 1 THEN EXIT SUB
IF BAUD = 1 THEN BAUD$ = "9600"
IF BAUD = 2 THEN BAUD$ = "19200"

CLOSE   '* Chuidi comunicazione aperta *

'* apri nuova comunicazione *
OPEN COM$ + ":" + BAUD$ + ",N,8,2,cs,ds,cd" FOR RANDOM AS #1

CALL UpdateStatusLine

END SUB

FUNCTION CMDSmorzamenti$ (send)

'** COMANDO ATTIVAZIONE/DISATTIVAZIONE SMORZAMENTO DELLA CORRENTE **
IF l = 1 THEN PRINT "Attivare smorzamento della corrente [0=NO o 1=SI] = ";
IF l = 2 THEN PRINT "Current damping activation [0=NO o 1=YES] = ";
IF l = 3 THEN PRINT "Current damping activation [0=NO o 1=YES] = ";

smorz = SpecialInput#(0, 1, 1)
IF ABORTCOMMAND = 1 THEN EXIT FUNCTION
IF smorz = 1 THEN smorz = &HFF

Comando$ = CHR$(&HEF) + CHR$(smorz)
CMDSmorzamenti$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

FUNCTION CMDStartTrigExt$ (send)
'** COMANDO START TRIGGER ESTERNO **
IF l = 1 THEN
	PRINT "Assegnazione ingressi per START TRIGGER esterno"
	PRINT "     INGRESSI [4321] [0XXX] = ";
END IF

IF l = 2 THEN
	PRINT "START TRIGGER inputs setting"
	PRINT "     INPUTS   [4321] [0XXX] = ";
END IF

IF l = 3 THEN
	PRINT "Einstellung START TRIGGER Eingang"
	PRINT "     Whlen Sie Eingnge [4321] [0XXX] = ";
END IF

ZeroIn = SpecialInput#(0, 1110, 4)

IF ABORTCOMMAND = 1 THEN EXIT FUNCTION
ZeroIn$ = RTRIM$(LTRIM$(STR$(ZeroIn)))

IF l = 1 THEN PRINT "     LIVELLI  [4321] [0XXX] = ";
IF l = 2 THEN PRINT "     LEVELS   [4321] [0XXX] = ";
IF l = 3 THEN PRINT "     low/high aktiv [0=LOW oder 1=HIGH] [4321] [0XXX] = ";

ZeroLev = SpecialInput#(0, 1110, 4)
IF ABORTCOMMAND = 1 THEN EXIT FUNCTION
ZeroLev$ = RTRIM$(LTRIM$(STR$(ZeroLev)))

'* Crezione byte con ingressi e livelli per zero al volo *
IF LEN(ZeroLev$) < 4 THEN ZeroLev$ = STRING$(4 - LEN(ZeroLev$), "0") + ZeroLev$
IF LEN(ZeroIn$) < 4 THEN ZeroIn$ = STRING$(4 - LEN(ZeroIn$), "0") + ZeroIn$

byte1$ = ZeroLev$ + ZeroIn$
CALL BinToDec(byte1$, byte1)

Comando$ = CHR$(&H29) + CHR$(byte1)
CMDStartTrigExt$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

FUNCTION CMDStartUltimo$ (send)
IF l = 1 THEN PRINT "Start ultimo posizionamento eseguito"
IF l = 2 THEN PRINT "Start last positioning"
IF l = 3 THEN PRINT "Wiederholung rel. Weg"

Comando$ = CHR$(&H2)
CMDStartUltimo$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

FUNCTION CMDStatoDrv1$ (send)
IF l = 1 THEN PRINT "Stato azionamento:"
IF l = 2 THEN PRINT "Drive status:"
IF l = 3 THEN PRINT "Endstufen Status:"

Comando$ = CHR$(&HAC)
CMDStatoDrv1$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)
  
IF RECEIVE$ <> "" THEN
   stato = ASC(RECEIVE$)
   CALL DecToBin(stato, stato$)
   PRINT "     Byte status ="; stato$
END IF

END FUNCTION

FUNCTION CMDStatoDrv2$ (send)

IF l = 1 THEN PRINT "Stato azionamento:"
IF l = 2 THEN PRINT "Drive status:"
IF l = 3 THEN PRINT "Endstufen Status:"

Comando$ = CHR$(&HAB)
CMDStatoDrv2$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 5)
  
IF (RECEIVE$ <> "" AND LEN(RECEIVE$) = 5) THEN
   IF MID$(RECEIVE$, 4, 1) <> "" THEN stato = ASC(MID$(RECEIVE$, 4, 1))
   CALL DecToBin(stato, stato$)
   PRINT "     Byte status ="; stato$
END IF

END FUNCTION

FUNCTION CMDStepGenNenc$ (send)

'** COMANDO IMPOSTAZIONE GENERAZIONE PASSO PER N IMPULSI ENCODER **
IF l = 1 THEN PRINT "N. impulsi encoder per 1 passo motore [da 100 a 2147483647] = ";
IF l = 2 THEN PRINT "N. encoder pulse for one step [from 100 to 2147483647] = ";
IF l = 3 THEN PRINT "N. encoder pulse for one step [from 100 to 2147483647] = ";

StepEnc# = SpecialInput#(0, 2147483647#, 10)
IF ABORTCOMMAND = 1 THEN EXIT FUNCTION

V# = StepEnc#

StepEnc1# = V# \ &H1000000
V# = V# MOD &H1000000

StepEnc2# = V# \ &H10000
V# = V# MOD &H10000

StepEnc3# = V# \ &H100
V# = V# MOD &H100

StepEnc4# = V#


Comando$ = CHR$(&HB5) + CHR$(StepEnc1#) + CHR$(StepEnc2#) + CHR$(StepEnc3#) + CHR$(StepEnc4#)
CMDStepGenNenc$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

FUNCTION CMDStop$ (send)
PRINT "Stop"

Comando$ = CHR$(&H11)
CMDStop$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)


END FUNCTION

FUNCTION CMDStopImm$ (send)
IF l = 1 THEN PRINT "Stop immediato"
IF l = 2 THEN PRINT "Stop without ramp"
IF l = 3 THEN PRINT "Stop without ramp"

Comando$ = CHR$(&H12)
CMDStopImm$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

FUNCTION CMDStopRmp$ (send)

IF l = 1 THEN PRINT "Stop con rampa"
IF l = 2 THEN PRINT "Stop with ramp"
IF l = 3 THEN PRINT "Stop with ramp"

Comando$ = CHR$(&H11)

CMDStopRmp$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

FUNCTION CMDStopTrigExt$ (send)
'** COMANDO STOP TRIGGER ESTERNO **
IF l = 1 THEN
	PRINT "Assegnazione ingressi per STOP TRIGGER esterno"
	PRINT "     INGRESSI [4321] [0XXX] = ";
END IF

IF l = 2 THEN
	PRINT "STOP TRIGGER inputs setting"
	PRINT "     INPUTS   [4321] [0XXX] = ";
END IF

IF l = 3 THEN
	PRINT "Sonderkondition STOP Eingnge mit and- Verknpfung"
	PRINT "     Whlen Sie die Eingnge [4321] [0XXX] = ";
END IF
ZeroIn = SpecialInput#(0, 1110, 4)
IF ABORTCOMMAND = 1 THEN EXIT FUNCTION
ZeroIn$ = RTRIM$(LTRIM$(STR$(ZeroIn)))

IF l = 1 THEN PRINT "     LIVELLI  [4321] [0XXX] = ";
IF l = 2 THEN PRINT "     LEVELS   [4321] [0XXX] = ";
IF l = 3 THEN PRINT "     low/high aktiv [0=LOW oder 1=HIGH] [4321] [0XXX] = ";

ZeroLev = SpecialInput#(0, 1110, 4)
IF ABORTCOMMAND = 1 THEN EXIT FUNCTION
ZeroLev$ = RTRIM$(LTRIM$(STR$(ZeroLev)))

'* Crezione byte con ingressi e livelli per zero al volo *
IF LEN(ZeroLev$) < 4 THEN ZeroLev$ = STRING$(4 - LEN(ZeroLev$), "0") + ZeroLev$
IF LEN(ZeroIn$) < 4 THEN ZeroIn$ = STRING$(4 - LEN(ZeroIn$), "0") + ZeroIn$

byte1$ = ZeroLev$ + ZeroIn$
CALL BinToDec(byte1$, byte1)

Comando$ = CHR$(&H2A) + CHR$(byte1)
CMDStopTrigExt$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

FUNCTION CMDStopTrigExtOr$ (send)
'** COMANDO STOP TRIGGER ESTERNO CON OR DEGLI INGRESSI**
IF l = 1 THEN
	PRINT "Assegnazione ingressi per STOP TRIGGER esterno (funzione OR)"
	PRINT "     INGRESSI [4321] [0XXX] = ";
END IF

IF l = 2 THEN
	PRINT "STOP TRIGGER inputs setting (OR function)"
	PRINT "     INPUTS   [4321] [0XXX] = ";
END IF

IF l = 3 THEN
	PRINT "Sonderkondition STOP Eingnge mit or- Verknpfung"
	PRINT "     Whlen Sie die Eingnge [4321] [0XXX] = ";
END IF

ZeroIn = SpecialInput#(0, 1110, 4)
IF ABORTCOMMAND = 1 THEN EXIT FUNCTION
ZeroIn$ = RTRIM$(LTRIM$(STR$(ZeroIn)))

IF l = 1 THEN PRINT "     LIVELLI  [4321] [0XXX] = ";
IF l = 2 THEN PRINT "     LEVELS   [4321] [0XXX] = ";
IF l = 3 THEN PRINT "     low/high aktiv [0=LOW oder 1=HIGH] [4321] [0XXX] = ";

ZeroLev = SpecialInput#(0, 1110, 4)
IF ABORTCOMMAND = 1 THEN EXIT FUNCTION
ZeroLev$ = RTRIM$(LTRIM$(STR$(ZeroLev)))

'* Crezione byte con ingressi e livelli per zero al volo *
IF LEN(ZeroLev$) < 4 THEN ZeroLev$ = STRING$(4 - LEN(ZeroLev$), "0") + ZeroLev$
IF LEN(ZeroIn$) < 4 THEN ZeroIn$ = STRING$(4 - LEN(ZeroIn$), "0") + ZeroIn$

byte1$ = ZeroLev$ + ZeroIn$
CALL BinToDec(byte1$, byte1)

Comando$ = CHR$(&HB1) + CHR$(byte1)
CMDStopTrigExtOr$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

FUNCTION CMDTipoDrv$ (send)
IF l = 1 THEN PRINT "Tipo azionamento"
IF l = 2 THEN PRINT "Pcb type"
IF l = 3 THEN PRINT "Endstufentyp"

Comando$ = CHR$(&H14)
CMDTipoDrv$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 5)
  
IF RECEIVE$ <> "" THEN
   aa = LEN(RECEIVE$)
   TipoDrv = ASC(MID$(RECEIVE$, aa - 1, 1))
   IF l = 1 THEN PRINT "     Tipo azionamento ="; TipoDrv
   IF l = 2 THEN PRINT "     Drive type ="; TipoDrv
   IF l = 3 THEN PRINT "     Drive type ="; TipoDrv
END IF

END FUNCTION

FUNCTION CMDVersioneSoft$ (send)

IF l = 1 THEN PRINT "Versione software"
IF l = 2 THEN PRINT "Software release"
IF l = 3 THEN PRINT "Software Version"

Comando$ = CHR$(&H10)
CMDVersioneSoft$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 5)

IF RECEIVE$ <> "" THEN
   aa = LEN(RECEIVE$)
   VerSoft = ASC(MID$(RECEIVE$, aa - 1, 1))
   IF l = 1 THEN PRINT "     Versione software = ";
   IF l = 2 THEN PRINT "     Software release = ";
   IF l = 3 THEN PRINT "     Software Version = ";
   PRINT LEFT$(HEX$(VerSoft), 1); "."; RIGHT$(HEX$(VerSoft), 1)
END IF

END FUNCTION

FUNCTION CMDVMax$ (send)
'** COMANDO IMPOSTAZIONE VELOCITA' MASSIMA **
IF l = 1 THEN PRINT "Velocit massima [da 0 a 5000 RPM] = ";
IF l = 2 THEN PRINT "Maximum speed [from 0 to 5000 RPM] = ";
IF l = 3 THEN PRINT "Maximum speed [from 0 to 5000 RPM] = ";

FMAX = SpecialInput#(0, 9000, 4)
IF ABORTCOMMAND = 1 THEN EXIT FUNCTION

Comando$ = CHR$(&H21) + CHR$(FMAX \ 256) + CHR$(FMAX MOD 256)
CMDVMax$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)


END FUNCTION

FUNCTION CMDVMin$ (send)
'** COMANDO IMPOSTAZIONE VELOCITA' MINIMA **
IF l = 1 THEN PRINT "Velocit minima [da 0 a 5000 RPM] = ";
IF l = 2 THEN PRINT "Minimum speed [from 0 to 5000 RPM] = ";
IF l = 3 THEN PRINT "Minimum speed [from 0 to 5000 RPM] = ";

FMIN = SpecialInput#(0, 9000, 4)
IF ABORTCOMMAND = 1 THEN EXIT FUNCTION

Comando$ = CHR$(&H20) + CHR$(FMIN \ 256) + CHR$(FMIN MOD 256)
CMDVMin$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

FUNCTION CMDZeroAlVolo$ (send)
'** COMANDO ZERO AL VOLO **
IF l = 1 THEN
	PRINT "Assegnazione ingressi per ZERO AL VOLO"
	PRINT "     INGRESSI [4321] [0XXX] = ";
END IF
IF l = 2 THEN
	PRINT "ZERO AT FLIGHT inputs setting"
	PRINT "     INPUTS   [4321] [0XXX] = ";
END IF
IF l = 3 THEN
	PRINT "Eingabe des Vefahrwegs ab Erkennung der Druckmarke"
	PRINT "     Whlen Sie den Eingang [4321] [0XXX] = ";
END IF

ZeroIn = SpecialInput#(0, 1110, 4)
IF ABORTCOMMAND = 1 THEN EXIT FUNCTION
ZeroIn$ = RTRIM$(LTRIM$(STR$(ZeroIn)))

IF l = 1 THEN PRINT "     LIVELLI  [4321] [0XXX] = ";
IF l = 2 THEN PRINT "     LEVELS   [4321] [0XXX] = ";
IF l = 3 THEN PRINT "     low/high aktiv [0=LOW oder 1=HIGH] [4321] [0XXX] = ";

ZeroLev = SpecialInput#(0, 1110, 4)
IF ABORTCOMMAND = 1 THEN EXIT FUNCTION
ZeroLev$ = RTRIM$(LTRIM$(STR$(ZeroLev)))

'* Crezione byte con ingressi e livelli per zero al volo *
IF LEN(ZeroLev$) < 4 THEN ZeroLev$ = STRING$(4 - LEN(ZeroLev$), "0") + ZeroLev$
IF LEN(ZeroIn$) < 4 THEN ZeroIn$ = STRING$(4 - LEN(ZeroIn$), "0") + ZeroIn$

byte1$ = ZeroLev$ + ZeroIn$
CALL BinToDec(byte1$, byte1)

IF l = 1 THEN PRINT "     Quota zero al volo = ";
IF l = 2 THEN PRINT "     Positioning = ";
IF l = 3 THEN PRINT "     Weg (25600 = 1 Umdr.) = ";

MOVREL# = SpecialInput#(-2147483647#, 2147483647#, 10)
IF ABORTCOMMAND = 1 THEN EXIT FUNCTION

IF (MOVREL# < 0) THEN
	MOVREL# = ABS(MOVREL#) - 1: QuotaNegativa = 1
ELSE
	QuotaNegativa = 0
END IF

V# = MOVREL#

MOVREL1# = V# \ &H1000000
V# = V# MOD &H1000000

MOVREL2# = V# \ &H10000
V# = V# MOD &H10000

MOVREL3# = V# \ &H100
V# = V# MOD &H100

MOVREL4# = V#


IF QuotaNegativa = 1 THEN
   MOVREL1# = &HFF - MOVREL1#
   MOVREL2# = &HFF - MOVREL2#
   MOVREL3# = &HFF - MOVREL3#
   MOVREL4# = &HFF - MOVREL4#
END IF

Comando$ = CHR$(&HA0) + CHR$(byte1) + CHR$(MOVREL1#) + CHR$(MOVREL2#) + CHR$(MOVREL3#) + CHR$(MOVREL4#)
CMDZeroAlVolo$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

SUB CommandDef
'***********************************
'* DEFINIZIONE STRINGHE DI COMANDO *
'* CON Byte_Nbyte_Addr=0           *
'***********************************


'---- COMANDI ----
CodUscita$ = CHR$(0) + CHR$(22)   ' CODICE DI ALT+U

Cmd0$ = CHR$(&HFC) + CHR$(0) + CHR$(&H29) + CHR$(&H11)
Cmd1$ = CHR$(&HFC) + CHR$(0) + CHR$(&H1)

Cmd3$ = CHR$(&HFC) + CHR$(0) + CHR$(&H27) + CHR$(&H7F)
Cmd6$ = CHR$(&HFC) + CHR$(0) + CHR$(&HA6)
Cmd7$ = CHR$(&HFC) + CHR$(0) + CHR$(&H2)
Cmd8$ = CHR$(&HFC) + CHR$(0) + CHR$(&H2C) + CHR$(&H44)
Cmd9$ = CHR$(&HFC) + CHR$(0) + CHR$(&H2A) + CHR$(&H22)
'CmdG$ = CHR$(&HFC) + CHR$(0) + CHR$(&H30) + CHR$(&H0) + CHR$(&H0) + CHR$(&H0) + CHR$(&H0)
CmdG$ = CHR$(&HFC) + CHR$(0) + CHR$(&H23) + CHR$(&H0) + CHR$(&H0) + CHR$(&H0) + CHR$(&H0)

CmdH$ = CHR$(&HFC) + CHR$(&HCF) + CHR$(&HA5) + CHR$(&HA6) + CHR$(&H15) + CHR$(&H16) + CHR$(&H17) + CHR$(&H18)

'CmdJ$ = CHR$(&HFC) + CHR$(0) + CHR$(&H31) + CHR$(&H0) + CHR$(&H0) + CHR$(&H64) + CHR$(&H0)
CmdL$ = CHR$(&HFC) + CHR$(0) + CHR$(&HA0) + CHR$(&H11) + CHR$(&H0) + CHR$(&H3) + CHR$(&HE8) + CHR$(&H0)
CmdM$ = CHR$(&HFC) + CHR$(0) + CHR$(&H32) + CHR$(&H0)
CmdN$ = CHR$(&HFC) + CHR$(0) + CHR$(&H32) + CHR$(&HFF)
CmdP$ = CHR$(&HFC) + CHR$(0) + CHR$(&H12)
CmdR$ = CHR$(&HFC) + CHR$(0) + CHR$(&H2B) + CHR$(&HFF)
CmdS$ = CHR$(&HFC) + CHR$(0) + CHR$(&H2B) + CHR$(&H0)

'* comandi multiaddress *
Cmd5$ = CHR$(&HFC) + CHR$(&HBF) + CHR$(&HA5) + CHR$(&H1) + CHR$(&H15) + CHR$(&H16) + CHR$(&H14)
CmdA$ = CHR$(&HFC) + CHR$(&H0) + CHR$(&H1) + CHR$(&H1)
CmdB$ = CHR$(&HFC) + CHR$(&H0) + CHR$(&H2) + CHR$(&H32) + CHR$(&H0)
CmdC$ = CHR$(&HFC) + CHR$(&HBF) + CHR$(&HA5) + CHR$(&H32) + CHR$(&HFF) + CHR$(&H15) + CHR$(&H16)
CmdX$ = CHR$(&HFC) + CHR$(&HBF) + CHR$(&HA5) + CHR$(&H11) + CHR$(&H15) + CHR$(&H16) + CHR$(&H18)


END SUB

FUNCTION ConvHEX$ (stringa$)
'***************************************************
'* Converte il parametro 'Stringa$' in una stringa *
'* di codici esadecimali spaziati                  *
'***************************************************

CoHEX$ = ""
LunghezzaStringa = LEN(stringa$)

FOR i = 1 TO LunghezzaStringa
	DatoHEX$ = LTRIM$(RTRIM$(HEX$(ASC(MID$(stringa$, i, 1)))))
	IF LEN(DatoHEX$) = 1 THEN DatoHEX$ = "0" + DatoHEX$

	CoHEX$ = CoHEX$ + " " + DatoHEX$
	
NEXT i
ConvHEX$ = CoHEX$

END FUNCTION

SUB decode (p$)
'* SUB DI DECODIFICA DEI COMANDI:
'*  IN: RECEIVE$ contenente il programma inviato dall'APS
'* OUT: array PRG$(n)  contenente il programma e decodifica
'*      array CODE$(n) contenente la decodifica delle istruzioni

PC = 1
i = 1
       
LungInst = 0

DO
	a = ASC(MID$(p$, i, 1))
	SELECT CASE a

	CASE &H1:
	  IF l = 1 THEN CODE$(PC) = "Reset"
	  IF l = 2 THEN CODE$(PC) = "Reset"
	  IF l = 3 THEN CODE$(PC) = "Reset"
	  LungInst = 1

	CASE &H2:
	  IF l = 1 THEN CODE$(PC) = "Start software"
	  IF l = 2 THEN CODE$(PC) = "Start software"
	  IF l = 3 THEN CODE$(PC) = "Start software"
	  LungInst = 1

	CASE &H10:
	  IF l = 1 THEN CODE$(PC) = "Versione software -> serial rx"
	  IF l = 2 THEN CODE$(PC) = "Software version -> serial rx"
	  IF l = 3 THEN CODE$(PC) = "Software version -> serial rx"
	  LungInst = 1

	CASE &H11:
	  IF l = 1 THEN CODE$(PC) = "Stop"
	  IF l = 2 THEN CODE$(PC) = "Stop"
	  IF l = 3 THEN CODE$(PC) = "Stop"
	  LungInst = 1

	CASE &H12:
	  IF l = 1 THEN CODE$(PC) = "Lettura posizione attuale -> serial rx"
	  IF l = 2 THEN CODE$(PC) = "present position -> serial rx"
	  IF l = 3 THEN CODE$(PC) = "present position -> serial rx"
	  LungInst = 1

	CASE &H13:
	  IF l = 1 THEN CODE$(PC) = "Lettura IN/OUT -> serial rx"
	  IF l = 2 THEN CODE$(PC) = "Read IN/OUT -> serial rx"
	  IF l = 3 THEN CODE$(PC) = "Read IN/OUT -> serial rx"
	  LungInst = 1

	CASE &H14:
	  IF l = 1 THEN CODE$(PC) = "Tipo azionamento -> serial rx"
	  IF l = 2 THEN CODE$(PC) = "PCB type -> serial rx"
	  IF l = 3 THEN CODE$(PC) = "PCB type -> serial rx"
	  LungInst = 1

	CASE &H20:
	  N# = ASC(MID$(p$, i + 1, 1)) * &H100 + ASC(MID$(p$, i + 2, 1))
	  IF l = 1 THEN CODE$(PC) = "Fmin =" + STR$(N#) + "Hz"
	  IF l = 2 THEN CODE$(PC) = "Fmin =" + STR$(N#) + "Hz"
	  IF l = 3 THEN CODE$(PC) = "Fmin =" + STR$(N#) + "Hz"
	  LungInst = 3

	CASE &H21:
	  N# = ASC(MID$(p$, i + 1, 1)) * &H100 + ASC(MID$(p$, i + 2, 1))
	  IF l = 1 THEN CODE$(PC) = "Fmax =" + STR$(N#) + "Hz"
	  IF l = 2 THEN CODE$(PC) = "Fmax =" + STR$(N#) + "Hz"
	  IF l = 3 THEN CODE$(PC) = "Fmax =" + STR$(N#) + "Hz"
	  LungInst = 3

	CASE &H22:
	  N# = ASC(MID$(p$, i + 1, 1))
	  IF l = 1 THEN CODE$(PC) = "Rampa =" + STR$(N#) + "cs"
	  IF l = 2 THEN CODE$(PC) = "Ramp =" + STR$(N#) + "cs"
	  IF l = 3 THEN CODE$(PC) = "Beschleunigung =" + STR$(N#) + "cs"
	  LungInst = 2
       
	CASE &H23:
	  n1# = ASC(MID$(p$, i + 1, 1)) * 256# * 256# * 256#  '16777216#
	  n2# = ASC(MID$(p$, i + 2, 1)) * 256# * 256#         ' 65536#
	  n3# = ASC(MID$(p$, i + 3, 1)) * 256#
	  n4# = ASC(MID$(p$, i + 4, 1))
	
	  N# = n1# + n2# + n3# + n4#
	  IF N# > ((256# ^ 4) / 2) THEN
		N# = (256# ^ 4) - N#: N$ = "-" + LTRIM$(STR$(N#))
	  ELSE
		N$ = LTRIM$(STR$(N#))
	  END IF
	  IF l = 1 THEN CODE$(PC) = "Posizione di home = " + N$
	  IF l = 2 THEN CODE$(PC) = "Home position = " + N$
	  IF l = 3 THEN CODE$(PC) = "Set-up nullpunkt = " + N$
	  LungInst = 5

	CASE &H26:
	  N# = ASC(MID$(p$, i + 1, 1))
	  IF N# = 0 THEN N$ = "1/1"
	  IF N# = 1 THEN N$ = "1/2"
	  IF N# = 2 THEN N$ = "1/4"
	  IF N# = 3 THEN N$ = "1/8"
	  IF N# = 4 THEN N$ = "1/16"
	  IF l = 1 THEN CODE$(PC) = "Risoluzione del passo = " + N$
	  IF l = 2 THEN CODE$(PC) = "Step resolution = " + N$
	  IF l = 3 THEN CODE$(PC) = "Motorschrittaufloesung = " + N$
	  LungInst = 2
       
	CASE &H27:
	  N = ASC(MID$(p$, i + 1, 1))
	 
	  IF l = 1 THEN CODE$(PC) = "Riduzione di corrente: byte rid = " + LTRIM$(ConvHEX$(CHR$(N)))
	  IF l = 2 THEN CODE$(PC) = "Current reduction: byte rid = " + LTRIM$(ConvHEX$(CHR$(N)))
	  IF l = 3 THEN CODE$(PC) = "Stromreduzierung: byte rid = " + LTRIM$(ConvHEX$(CHR$(N)))
	 
	  LungInst = 2
       
	CASE &H28:
	  N = ASC(MID$(p$, i + 1, 1)) * 512
	  IF l = 1 THEN CODE$(PC) = "Ritardo seriale =" + STR$(N) + " s"
	  IF l = 2 THEN CODE$(PC) = "Serial delay =" + STR$(N) + " s"
	  IF l = 3 THEN CODE$(PC) = "Serial delay =" + STR$(N) + " s"
	  LungInst = 2
       
	CASE &H29:
	  N = ASC(MID$(p$, i + 1, 1))
	  CALL DecToBin(N, N$)
	  n1$ = RIGHT$(N$, 4)
	  n2$ = LEFT$(N$, 4)
	  IF l = 1 THEN CODE$(PC) = "Start trigger: IN:" + n1$ + " LIVELLI:" + n2$
	  IF l = 2 THEN CODE$(PC) = "Start trigger: IN:" + n1$ + " LEVELS:" + n2$
	  IF l = 3 THEN CODE$(PC) = "Start trigger: IN:" + n1$ + " LEVELS:" + n2$
	  LungInst = 2
       
	CASE &H2A:
	  N = ASC(MID$(p$, i + 1, 1))
	  CALL DecToBin(N, N$)
	  n1$ = RIGHT$(N$, 4)
	  n2$ = LEFT$(N$, 4)
	  IF l = 1 THEN CODE$(PC) = "Stop trigger: IN:" + n1$ + " LIVELLI:" + n2$
	  IF l = 2 THEN CODE$(PC) = "Stop trigger: IN:" + n1$ + " LEVELS:" + n2$
	  IF l = 3 THEN CODE$(PC) = "Stop trigger: IN:" + n1$ + " LEVELS:" + n2$
	  LungInst = 2
       
	CASE &H2B:
	  N = ASC(MID$(p$, i + 1, 1))
	  IF N > 0 THEN N = 1
	  IF l = 1 THEN CODE$(PC) = "'Livello 'IN POSITION'=" + STR$(N)
	  IF l = 2 THEN CODE$(PC) = "'IN POSITION' level =" + STR$(N)
	  IF l = 3 THEN CODE$(PC) = "'IN POSITION' level =" + STR$(N)
	  LungInst = 2
      
	CASE &H2C:
	  N = ASC(MID$(p$, i + 1, 1))
	  CALL DecToBin(N, N$)
	  n1$ = RIGHT$(N$, 4)
	  n2$ = LEFT$(N$, 4)
	  IF l = 1 THEN CODE$(PC) = "Home trigger: IN:" + n1$ + " LIVELLI:" + n2$
	  IF l = 2 THEN CODE$(PC) = "Home trigger: IN:" + n1$ + " LEVELS:" + n2$
	  IF l = 3 THEN CODE$(PC) = "Home trigger: IN:" + n1$ + " LEVELS:" + n2$
	  LungInst = 2
       
	CASE &H30:
	  n1# = ASC(MID$(p$, i + 1, 1)) * 256# * 256# * 256#  '16777216#
	  n2# = ASC(MID$(p$, i + 2, 1)) * 256# * 256#         ' 65536#
	  n3# = ASC(MID$(p$, i + 3, 1)) * 256#
	  n4# = ASC(MID$(p$, i + 4, 1))
	 
	  N# = n1# + n2# + n3# + n4#
	  IF N# > ((256# ^ 4) / 2) THEN
		N# = (256# ^ 4) - N#: N$ = "-" + LTRIM$(STR$(N#))
	  ELSE
		N$ = LTRIM$(STR$(N#))
	  END IF
	  IF l = 1 THEN CODE$(PC) = "Posizionamento assoluto = " + N$
	  IF l = 2 THEN CODE$(PC) = "Absolute positioning = " + N$
	  IF l = 3 THEN CODE$(PC) = "Absoluter weg = " + N$
	  LungInst = 5
       
	CASE &H31:
	  PRINT "len P$ ="; LEN(p$)
	  n1# = ASC(MID$(p$, i + 1, 1)) * 256# * 256# * 256#  '16777216#
	  n2# = ASC(MID$(p$, i + 2, 1)) * 256# * 256#         ' 65536#
	  n3# = ASC(MID$(p$, i + 3, 1)) * 256#
	  n4# = ASC(MID$(p$, i + 4, 1))
	 
	  N# = n1# + n2# + n3# + n4#
	  IF N# > ((256# ^ 4) / 2) THEN
		N# = (256# ^ 4) - N#: N$ = "-" + LTRIM$(STR$(N#))
	  ELSE
		N$ = LTRIM$(STR$(N#))
	  END IF
	  IF l = 1 THEN CODE$(PC) = "Posizionamento relativo = " + N$
	  IF l = 2 THEN CODE$(PC) = "Relative positioning = " + N$
	  IF l = 3 THEN CODE$(PC) = "Relativer weg = " + N$
	  LungInst = 5
       
	CASE &H32:
	  N = ASC(MID$(p$, i + 1, 1))
	  IF N = 0 THEN N$ = "CW" ELSE N$ = "CCW"
	  IF l = 1 THEN CODE$(PC) = "Movimento infinito " + N$
	  IF l = 2 THEN CODE$(PC) = "Infinite motion " + N$
	  IF l = 3 THEN CODE$(PC) = "Dauerlauf " + N$
	  LungInst = 2
     
	CASE &HA0:
	  N = ASC(MID$(p$, i + 1, 1))
	  CALL DecToBin(N, N$)
	  n1$ = RIGHT$(N$, 4)
	  n2$ = LEFT$(N$, 4)
	  IF l = 1 THEN CODE$(PC) = "Zero al volo: IN:" + n1$ + " LIV:" + n2$
	  IF l = 2 THEN CODE$(PC) = "Zero at flight: IN:" + n1$ + " LEV:" + n2$
	  IF l = 3 THEN CODE$(PC) = "Zero at flight: IN:" + n1$ + " LEV:" + n2$
	 
	  n1# = ASC(MID$(p$, i + 2, 1)) * 256# * 256# * 256#  '16777216#
	  n2# = ASC(MID$(p$, i + 3, 1)) * 256# * 256#         ' 65536#
	  n3# = ASC(MID$(p$, i + 4, 1)) * 256#
	  n4# = ASC(MID$(p$, i + 5, 1))
	 
	  N# = n1# + n2# + n3# + n4#
	  IF N# > ((256# ^ 4) / 2) THEN
		N# = (256# ^ 4) - N#: N$ = "-" + LTRIM$(STR$(N#))
	  ELSE
		N$ = LTRIM$(STR$(N#))
	  END IF
	 
	  IF l = 1 THEN CODE$(PC) = CODE$(PC) + " Q.ta=" + N$
	  IF l = 2 THEN CODE$(PC) = CODE$(PC) + " Q.te=" + N$
	  IF l = 3 THEN CODE$(PC) = CODE$(PC) + " Q.te=" + N$
	  LungInst = 6
       
	CASE &HA6:
	  IF l = 1 THEN CODE$(PC) = "Vai alla posizione di zero"
	  IF l = 2 THEN CODE$(PC) = "Go to home position"
	  IF l = 3 THEN CODE$(PC) = "Go to home position"
	  LungInst = 1
       
	CASE &HA8:
	  N# = ASC(MID$(p$, i + 1, 1)) * &H100 + ASC(MID$(p$, i + 2, 1))
	  IF l = 1 THEN CODE$(PC) = "Corrente =" + STR$(N#) + "mA"
	  IF l = 2 THEN CODE$(PC) = "Current =" + STR$(N#) + "mA"
	  IF l = 3 THEN CODE$(PC) = "Ausgangsstrom =" + STR$(N#) + "mA"
	  LungInst = 3
       
	CASE &HAA:
	  n1# = ASC(MID$(p$, i + 1, 1)) * 256# * 256# * 256#  '16777216#
	  n2# = ASC(MID$(p$, i + 2, 1)) * 256# * 256#         ' 65536#
	  n3# = ASC(MID$(p$, i + 3, 1)) * 256#
	  n4# = ASC(MID$(p$, i + 4, 1))
	 
	  N# = n1# + n2# + n3# + n4#
	  IF N# > ((256# ^ 4) / 2) THEN
		N# = (256# ^ 4) - N#: N$ = "-" + LTRIM$(STR$(N#))
	  ELSE
		N$ = LTRIM$(STR$(N#))
	  END IF
	  IF l = 1 THEN CODE$(PC) = "Quota relativa senza esecuzione = " + N$
	  IF l = 2 THEN CODE$(PC) = "Relative positioning (no exec) = " + N$
	  IF l = 3 THEN CODE$(PC) = "Relative positioning (no exec) = " + N$
	  LungInst = 5
       
	CASE &HAB:
	  IF l = 1 THEN CODE$(PC) = "Stato azionamento 1-> serial rx"
	  IF l = 2 THEN CODE$(PC) = "Drive Status 1 -> serial rx"
	  IF l = 3 THEN CODE$(PC) = "Drive Status 1 -> serial rx"
	  LungInst = 1

	CASE &HAC:
	  IF l = 1 THEN CODE$(PC) = "Stato azionamento 2-> serial rx"
	  IF l = 2 THEN CODE$(PC) = "Drive Status 2 -> serial rx"
	  IF l = 3 THEN CODE$(PC) = "Drive Status 2 -> serial rx"
	  LungInst = 1
       
	CASE &HAD:
	  N# = ASC(MID$(p$, i + 1, 1))
	  IF l = 1 THEN CODE$(PC) = "Cambio velocit =" + STR$(N#) + "%"
	  IF l = 2 THEN CODE$(PC) = "Change speed =" + STR$(N#) + "%"
	  IF l = 3 THEN CODE$(PC) = "Change speed =" + STR$(N#) + "%"
	  LungInst = 2
       
	CASE &HAE:
	  n1# = ASC(MID$(p$, i + 1, 1)) * 256# * 256# * 256#  '16777216#
	  n2# = ASC(MID$(p$, i + 2, 1)) * 256# * 256#         ' 65536#
	  n3# = ASC(MID$(p$, i + 3, 1)) * 256#
	  n4# = ASC(MID$(p$, i + 4, 1))
	 
	  N# = n1# + n2# + n3# + n4#
	  IF N# > ((256# ^ 4) / 2) THEN
		N# = (256# ^ 4) - N#: N$ = "-" + LTRIM$(STR$(N#))
	  ELSE
		N$ = LTRIM$(STR$(N#))
	  END IF
	  IF l = 1 THEN CODE$(PC) = "Posizione assoluta = " + N$
	  IF l = 2 THEN CODE$(PC) = "Absolute position = " + N$
	  IF l = 3 THEN CODE$(PC) = "Absolute position = " + N$
	  LungInst = 5
       
	CASE &HAF:
	  N = ASC(MID$(p$, i + 1, 1))
	  CALL DecToBin(N, N$)
	  n1$ = RIGHT$(N$, 4)
	  n2$ = LEFT$(N$, 4)
	  IF l = 1 THEN CODE$(PC) = "Azzeramento asse: IN:" + n1$ + " LIVELLI:" + n2$
	  IF l = 2 THEN CODE$(PC) = "Axis zeroing: IN:" + n1$ + " LEVELS:" + n2$
	  IF l = 3 THEN CODE$(PC) = "Achse Referenzlauf: IN:" + n1$ + " LEVELS:" + n2$
	  LungInst = 2
       
	CASE &HB0:
	  N = ASC(MID$(p$, i + 1, 1))
	  CALL DecToBin(N, N$)
	  n1$ = RIGHT$(N$, 4)
	  n2$ = LEFT$(N$, 4)
	  IF l = 1 THEN CODE$(PC) = "Extracorsa: IN:" + n1$ + " LIVELLI:" + n2$
	  IF l = 2 THEN CODE$(PC) = "Extra-switch: IN:" + n1$ + " LEVELS:" + n2$
	  IF l = 3 THEN CODE$(PC) = "Extra-switch: IN:" + n1$ + " LEVELS:" + n2$
	  LungInst = 2
       
	CASE &HB1:
	  N = ASC(MID$(p$, i + 1, 1))
	  CALL DecToBin(N, N$)
	  n1$ = RIGHT$(N$, 4)
	  n2$ = LEFT$(N$, 4)
	  IF l = 1 THEN CODE$(PC) = "Stop trigger: IN:" + n1$ + " LIVELLI:" + n2$
	  IF l = 2 THEN CODE$(PC) = "Stop trigger: IN:" + n1$ + " LEVELS:" + n2$
	  IF l = 3 THEN CODE$(PC) = "Stop trigger: IN:" + n1$ + " LEVELS:" + n2$
	  LungInst = 2
       
	CASE &HB2:
	  n1# = ASC(MID$(p$, i + 1, 1)) * 256# * 256# * 256#  '16777216#
	  n2# = ASC(MID$(p$, i + 2, 1)) * 256# * 256#         ' 65536#
	  n3# = ASC(MID$(p$, i + 3, 1)) * 256#
	  n4# = ASC(MID$(p$, i + 4, 1))
	 
	  N# = n1# + n2# + n3# + n4#
	  IF N# > ((256# ^ 4) / 2) THEN
		N# = (256# ^ 4) - N#: N$ = "-" + LTRIM$(STR$(N#))
	  ELSE
		N$ = LTRIM$(STR$(N#))
	  END IF
	  IF l = 1 THEN CODE$(PC) = "Quota iniziale zero al volo = " + N$
	  IF l = 2 THEN CODE$(PC) = "Start quote zero at flight = " + N$
	  IF l = 3 THEN CODE$(PC) = "Start quote zero at flight = " + N$
	  LungInst = 5

	CASE &HB3:
	  n1# = ASC(MID$(p$, i + 1, 1)) * 256# * 256# * 256#  '16777216#
	  n2# = ASC(MID$(p$, i + 2, 1)) * 256# * 256#         ' 65536#
	  n3# = ASC(MID$(p$, i + 3, 1)) * 256#
	  n4# = ASC(MID$(p$, i + 4, 1))
	
	  N# = n1# + n2# + n3# + n4#
	  IF l = 1 THEN CODE$(PC) = "Passi di frenata =" + STR$(N#)
	  IF l = 2 THEN CODE$(PC) = "Brake steps =" + STR$(N#)
	  IF l = 3 THEN CODE$(PC) = "Brake steps =" + STR$(N#)
	  LungInst = 5
       
	CASE &HB4:
	  n1# = ASC(MID$(p$, i + 1, 1)) * 256# * 256# * 256#  '16777216#
	  n2# = ASC(MID$(p$, i + 2, 1)) * 256# * 256#         ' 65536#
	  n3# = ASC(MID$(p$, i + 3, 1)) * 256#
	  n4# = ASC(MID$(p$, i + 4, 1))
	 
	  N# = n1# + n2# + n3# + n4#
	  IF N# > ((256# ^ 4) / 2) THEN
		N# = (256# ^ 4) - N#: N$ = "-" + LTRIM$(STR$(N#))
	  ELSE
		N$ = LTRIM$(STR$(N#))
	  END IF
	  IF l = 1 THEN CODE$(PC) = "Quota di anticipo fine pos. = " + N$
	  IF l = 2 THEN CODE$(PC) = "Pre-end position quote = " + N$
	  IF l = 3 THEN CODE$(PC) = "Pre-end position quote = " + N$
	  LungInst = 5
      
	CASE &HB5:
	  N = ASC(MID$(p$, i + 1, 1))
	  IF N = 0 THEN N$ = "NO" ELSE IF l = 1 THEN N$ = "SI" ELSE N$ = "YES"
	  IF l = 1 THEN CODE$(PC) = "Attivazione uscita passi (TOGGLE) = " + N$
	  IF l = 2 THEN CODE$(PC) = "Steps out active = " + N$
	  IF l = 3 THEN CODE$(PC) = "Steps out active = " + N$
	  LungInst = 2
       
	CASE &HF5:
	  IF l = 1 THEN CODE$(PC) = "Ripetizione programma"
	  IF l = 2 THEN CODE$(PC) = "Repeat program"
	  IF l = 3 THEN CODE$(PC) = "Satz wiederholen"
	  LungInst = 1
       
	CASE &HF4:
	  N# = ASC(MID$(p$, i + 1, 1))
	  IF l = 1 THEN CODE$(PC) = "Pausa =" + STR$(N# / 10) + "s"
	  IF l = 2 THEN CODE$(PC) = "Pause =" + STR$(N# / 10) + "s"
	  IF l = 3 THEN CODE$(PC) = "Pause =" + STR$(N# / 10) + "s"
	  LungInst = 2

	CASE ELSE
	    PRG$(PC) = ""
	    CODE$(PC) = "-- NO DECODE --"
       
	END SELECT
       
	IF (LungInst > 0) THEN
		PRG$(PC) = MID$(p$, i, LungInst)
		i = i + LungInst
		PC = PC + 1
	ELSE
		PRG$(PC) = ""
		i = i + 1
	END IF
	   
	PrimoByte = 0
       
	IF i > (LEN(p$) - 1) THEN EXIT DO         'scarto lo 0x06
LOOP


END SUB

SUB DecToBin (ValoreDec, Bin$)

'***********************************************
'* Converte un numero decimale in uno binario  *
'* costituito da una stringa di otto caratteri *
'***********************************************
DIM b$(10)

'* Azzero il vettore binario *
FOR i = 1 TO 8
	b$(i) = "0"
NEXT i

a = ValoreDec
index = 0

DO
	index = index + 1
	b = INT(a / 2)
	resto = a MOD 2
	b$(index) = LTRIM$(RTRIM$(STR$(resto)))  '* il resto vale 0 oppure 1 *
	IF b = 0 THEN EXIT DO                    '* fine conversione *
       
	a = b                                    '* nuovo valore da processare *
LOOP

'* il vettore di stringa b$ continene il valore binario *
Bin$ = ""

FOR i = 8 TO 1 STEP -1
	Bin$ = Bin$ + b$(i)
NEXT i

END SUB

'
' ========================= FILTRO ==========================
'     Filtra i caratteri nella stringa di input.
' ============================================================
'
SUB Filtro (StringaIn$) STATIC

   ' Cerca i caratteri di ritorno unitario e li sostituisce con
   ' CHR$(29) (la freccia SINISTRA):
   DO
      RitUn = INSTR(StringaIn$, CHR$(8))
      IF RitUn THEN
	 MID$(StringaIn$, RitUn) = CHR$(29)
      END IF
   LOOP WHILE RitUn

   ' Cerca i caratteri di interlinea e li elimina:
   DO
      InterLin = INSTR(StringaIn$, CHR$(10))
      IF InterLin THEN
	 StringaIn$ = LEFT$(StringaIn$, InterLin - 1) + MID$(StringaIn$, InterLin + 1)
      END IF
   LOOP WHILE InterLin

END SUB

FUNCTION InsertCMD$

DO
   IF TOGGLECOLOR = 0 THEN
	TOGGLECOLOR = 1
	COLORECOM = COLORECOM1
   ELSE
	TOGGLECOLOR = 0
	COLORECOM = COLORECOM2
	COLOR COLORECOM2
   END IF
 
   COLOR COLORECOM

   TIPOCOMANDO = 1           '* comando con risposta *

   PRINT "CMD> ";
  
   DO
	TastoInput$ = INKEY$
   
	IF TastoInput$ <> "" THEN
		IF TastoInput$ = "F" THEN
			TastoInput1$ = INKEY$
			IF TastoInput1$ <> "" THEN TastoInput$ = "F" + TastoInput1$
		END IF
		      
		IF LEFT$(TastoInput$, 1) = CHR$(0) THEN
			TastoInput1$ = RIGHT$(TastoInput$, 1)
			IF TastoInput1$ <> "" THEN TastoInput$ = "S" + TastoInput1$
		END IF
		EXIT DO
	END IF
   LOOP

   Comando$ = ""
  
   SELECT CASE UCASE$(TastoInput$)
	CASE CHR$(27):
		IF l = 1 THEN PRINT "VUOI RITORNARE ALL'EDITOR ? [1=SI 0=NO] ";
		IF l = 2 THEN PRINT "RETURN TO EDITOR ? [1=YES 0=NO] ";
		IF l = 3 THEN PRINT "RETURN TO EDITOR ? [1=YES 0=NO] ";
		x = SpecialInput#(0, 1, 1)
	       
		IF (ABORTCOMMAND <> 1) THEN
		   IF x = 1 THEN Comando$ = "ABORT": EXIT DO
		END IF

	CASE "F7": Comando$ = PRGCMDRepeat$(0): EXIT DO
	CASE "F8": Comando$ = PRGCMDPausa$(0): EXIT DO
	CASE "3": Comando$ = CMDReset$(0): EXIT DO
	CASE "4": Comando$ = CMDCurrentSet$(0): EXIT DO
	CASE "5": Comando$ = CMDFMin$(0): EXIT DO
	CASE "6": Comando$ = CMDFMax$(0): EXIT DO
	CASE "7": Comando$ = CMDRampa$(0): EXIT DO
	CASE "8": Comando$ = CMDMovRelativo$(0): EXIT DO
	CASE "9": Comando$ = CMDMovAssoluto$(0): EXIT DO
	CASE "A": Comando$ = CMDMovInfinito$(0): EXIT DO
	CASE "B": Comando$ = CMDStartUltimo$(0): EXIT DO
	CASE "C": Comando$ = CMDStop$(0): EXIT DO
	CASE "D": Comando$ = CMDSetHome$(0): EXIT DO
	CASE "E": Comando$ = CMDLetturaPosiz$(0): EXIT DO
	CASE "F": Comando$ = CMDDivisionePasso$(0): EXIT DO
	CASE "G": Comando$ = CMDRiduzioneCorr$(0): EXIT DO
	CASE "H": Comando$ = CMDLivelloInPos$(0): EXIT DO
	CASE "I": Comando$ = CMDRitardoSeriale$(0): EXIT DO
	CASE "J": Comando$ = CMDVersioneSoft$(0): EXIT DO
	CASE "K": Comando$ = CMDTipoDrv$(0): EXIT DO
	CASE "L": Comando$ = CMDZeroAlVolo$(0): EXIT DO
	CASE "M": Comando$ = CMDStatoDrv1$(0): EXIT DO
	CASE "N": Comando$ = CMDStatoDrv2$(0): EXIT DO
	CASE "O": Comando$ = CMDPercVelocita$(0): EXIT DO
	CASE "Q": CALL CMDQuotaGiro:    ABORTCOMMAND = 1
	CASE "R": Comando$ = CMDQuotamm$(0): EXIT DO
	CASE "S": Comando$ = CMDQuotammNoPos$(0): EXIT DO
	CASE "T": Comando$ = CMDStopTrigExt$(0): EXIT DO
	CASE "U": Comando$ = CMDStartTrigExt$(0): EXIT DO
	CASE "V": Comando$ = CMDExtracorsa$(0): EXIT DO
	CASE "Z": Comando$ = CMDAzzeramento$(0): EXIT DO
	CASE "W": Comando$ = CMDStopTrigExtOr$(0): EXIT DO
	CASE "O": Comando$ = CMDFMaxMOV$(0): EXIT DO
	CASE "Y": Comando$ = CMDQuotaInizialeZfly$(0): EXIT DO
   CASE ELSE
	TIPOCOMANDO = 10
	PRINT
   END SELECT

LOOP
  
   ABORTCOMMAND = 0
   TIPOCOMANDO = 1
 
   CALL UpdateStatusLine

   InsertCMD$ = Comando$    '*assegna alla func il comando ricevuto

END FUNCTION

SUB MascheraABS

'*****************************************
'* STAMPA MASCHERA COMANDI SULLO SCHERMO *
'*****************************************

DIM m$(40)

DRIVER$ = "ABS"

'----- Descrizione comandi sul video ---------
VIEW PRINT 1 TO 24
COLOR 0, 7                       ' Imposta il colore dello schermo.
LOCATE 1, 1, 1: PRINT STRING$(80, "-");
IF l = 1 THEN LOCATE 1, 27, 1: PRINT " i.v.b. STAR 2000 TERMINAL "
IF l = 2 THEN LOCATE 1, 27, 1: PRINT " i.v.b. STAR 2000 TERMINAL "
IF l = 3 THEN LOCATE 1, 27, 1: PRINT " i.v.b. STAR 2000 PROGRAMM "
LOCATE 1, 70: PRINT " Ver "; DSTARVERSION$; " "

COLOR 0, 3                        ' Imposta il colore dello schermo.
LOCATE 10, 1, 1: PRINT STRING$(80, "-");
LOCATE 10, 29, 1: PRINT " ABS DRIVES COMMANDS "
COLOR 7, 1                        ' Imposta il colore dello schermo.


IF l = 1 THEN
	m$(1) = "0 Selezione drive"
	m$(2) = "1 Parametri seriali"
	m$(3) = "2 Indirizzo drive"
	m$(4) = "3 Reset"
	m$(5) = "4 Velocit minima"
	m$(6) = "5 Velocit massima"
	m$(7) = "6 Rampa"
	m$(8) = "7 Movimento infinito"
	m$(9) = "8 Stop con rampa"
	m$(10) = "9 Stop immediato (senza rampa)"
	m$(11) = "A Ritardo seriale"
	m$(12) = "B Versone software"
	m$(13) = "C Tipo scheda"
	m$(14) = "D Perc. errore di velocit"
	m$(15) = "E Rampa di decelerazione"
END IF

IF l = 2 THEN
	m$(1) = "0 Drive selection"
	m$(2) = "1 Serial parameters"
	m$(3) = "2 Drive address"
	m$(4) = "3 Reset"
	m$(5) = "4 Min speed setting"
	m$(6) = "5 Max speed setting"
	m$(7) = "6 Ramp setting"
	m$(8) = "7 Infinite motion"
	m$(9) = "8 Stop with ramp"
	m$(10) = "9 Stop without ramp"
	m$(11) = "A Serial answer delay"
	m$(12) = "B Software release"
	m$(13) = "C PCB type"
	m$(14) = "D Speed correction err"
	m$(15) = "E Deceleration ramp"
END IF

IF l = 3 THEN
	m$(1) = "0 Auswahl Endstufe"
	m$(2) = "1 Schnittstellenparameter"
	m$(3) = "2 Adresse Endstufe"
	m$(4) = "3 Reset"
	m$(5) = "4 Min speed setting"
	m$(6) = "5 Max speed setting"
	m$(7) = "6 Beschleunigung"
	m$(8) = "7 Dauerlauf"
	m$(9) = "8 Stop with ramp"
	m$(10) = "9 Stop without ramp"
	m$(11) = "A Serial answer delay"
	m$(12) = "B Software release"
	m$(13) = "C PCB type"
	m$(14) = "D Speed correction err"
	m$(15) = "E Deceleration ramp"
END IF

j = 0
k = 0
FOR i = 1 TO 15
   a$ = LEFT$(m$(i), 1)
   IF a$ <> "-" THEN
	LOCATE 12 + j, 1 + k: COLOR 11, 1: PRINT LEFT$(m$(i), 2);
   ELSE
	LOCATE 12 + j, 1 + k: COLOR 7, 1: PRINT LEFT$(m$(i), 2);
   END IF

   COLOR 7, 1: PRINT RIGHT$(m$(i), LEN(m$(i)) - 2);
   j = j + 1
   IF j > 12 THEN j = 0: k = k + 27
NEXT i

VIEW PRINT 2 TO 10      '* Stampa tra le righe 1 e 15.

CALL UpdateStatusLine

END SUB

SUB MascheraAPS

'*****************************************
'* STAMPA MASCHERA COMANDI SULLO SCHERMO *
'*****************************************

DIM m$(40)

DRIVER$ = "APS"

'----- Descrizione comandi sul video ---------
VIEW PRINT 1 TO 24
COLOR 0, 7                       ' Imposta il colore dello schermo.
LOCATE 1, 1, 1: PRINT STRING$(80, "-");
IF l = 1 THEN LOCATE 1, 27, 1: PRINT " i.v.b. STAR 2000 TERMINAL "
IF l = 2 THEN LOCATE 1, 27, 1: PRINT " i.v.b. STAR 2000 TERMINAL "
IF l = 3 THEN LOCATE 1, 27, 1: PRINT " i.v.b. STAR 2000 PROGRAMM "
LOCATE 1, 70: PRINT " Ver "; DSTARVERSION$; " "

COLOR 0, 3                        ' Imposta il colore dello schermo.
LOCATE 10, 1, 1: PRINT STRING$(80, "-");
LOCATE 10, 33, 1: PRINT " APS COMMANDS "
COLOR 7, 1                        ' Imposta il colore dello schermo.


IF l = 1 THEN
	m$(1) = "0 Selezione drive"
	m$(2) = "1 Parametri seriali"
	m$(3) = "2 Indirizzo drive"
	m$(4) = "3 Reset"
	m$(5) = "4 Corrente"
	m$(6) = "5 Frequenza minima"
	m$(7) = "6 Frequenza massima"
	m$(8) = "7 Rampa"
	m$(9) = "8 Posizionamento relativo"
	m$(10) = "9 Posizionamento assoluto"
	m$(11) = "A Movimento infinito"
	m$(12) = "B Ripeti l'ultimo posiz."
	m$(13) = "C Stop"
	m$(14) = "D Posizione di home"
	m$(15) = "E Lettura posiz. attuale"
	m$(16) = "F Risoluzione del motore"
	m$(17) = "G Riduzione di corrente"
	m$(18) = "H Livello uscita 'IN POS'"
	m$(19) = "I Ritardo seriale"
	m$(20) = "J Versione software"
	m$(21) = "K Tipo drive"
	m$(22) = "L Zero al volo"
	m$(23) = "M Stato driver 1"
	m$(24) = "N Stato driver 2"
	m$(25) = "O Cambio velocit al volo"
	m$(26) = "Q Quota per 1 giro"
	m$(27) = "R Pos.Relativo [mm]"
	m$(28) = "S Pos.Relativo [mm] caric."
	m$(29) = "T Stop trigger esterno"
	m$(30) = "U Start trigger esterno"
	m$(31) = "V Set Extra corsa"
	m$(32) = "W Stop trigger esterno OR"
	m$(33) = "X Vai a home"
	m$(34) = "Y Quota iniziale z.fly"
	m$(35) = "Z Azzeramento"
END IF

IF l = 2 THEN
	m$(1) = "0 Drive selection"
	m$(2) = "1 Serial parameters"
	m$(3) = "2 Drive address"
	m$(4) = "3 Reset"
	m$(5) = "4 Current setting"
	m$(6) = "5 Min frequency setting"
	m$(7) = "6 Max frequency setting"
	m$(8) = "7 Ramp setting"
	m$(9) = "8 Relative position"
	m$(10) = "9 Absolute position"
	m$(11) = "A Infinite motion"
	m$(12) = "B Start last position"
	m$(13) = "C Stop"
	m$(14) = "D Home position setting"
	m$(15) = "E Read present position"
	m$(16) = "F Motor resolution set"
	m$(17) = "G Current reduction set"
	m$(18) = "H 'IN POSITION' out level"
	m$(19) = "I Serial answer delay"
	m$(20) = "J Software version"
	m$(21) = "K Drive type"
	m$(22) = "L Zero at flight"
	m$(23) = "M Drive status 1"
	m$(24) = "N Drive status 2"
	m$(25) = "O Speed change on the fly"
	m$(26) = "Q Quote/revolution"
	m$(27) = "R Rel.pos. [mm]"
	m$(28) = "S Rel.Pos. [mm] no exec"
	m$(29) = "T Stop extern trigger"
	m$(30) = "U Start extern trigger"
	m$(31) = "V Limit-switch +/-"
	m$(32) = "W Stop extern trigger OR"
	m$(33) = "X Go home"
	m$(34) = "Y Set start zfly quote"
	m$(35) = "Z Axis zeroing"
END IF

IF l = 3 THEN
	m$(1) = "0 Auswahl Endstufentyp"
	m$(2) = "1 Schnittstellenparameter"
	m$(3) = "2 Adresse Endstufe"
	m$(4) = "3 Reset"
	m$(5) = "4 Motorstrom Einstell."
	m$(6) = "5 min. Frequenz"
	m$(7) = "6 max. Frequenz"
	m$(8) = "7 Beschleunigung"
	m$(9) = "8 relativer Weg"
	m$(10) = "9 absoluter Weg"
	m$(11) = "A Dauerlauf"
	m$(12) = "B Wiederholung rel. Weg"
	m$(13) = "C Stop"
	m$(14) = "D Nullpunkt Einstell."
	m$(15) = "E aktuelle Position"
	m$(16) = "F Motorschrittaufloesung"
	m$(17) = "G Stromreduzierung"
	m$(18) = "H 'IN POSITION' Einstell."
	m$(19) = "I Zeitverz. ser. Antwort"
	m$(20) = "J Softwareversion"
	m$(21) = "K Endstufentyp"
	m$(22) = "L Druckmarken Verfahrweg"
	m$(23) = "M Endstufe Status 1"
	m$(24) = "N Endstufe Status 2"
	m$(25) = "O Drehzahlnd.w.Bewegung"
	m$(26) = "Q Eingabe Weg/Umdrehung"
	m$(27) = "R Rel.Weg [mm]"
	m$(28) = "S Rel.Weg [mm] ohne Ausf."
	m$(29) = "T Stop ext. Trigger Eing."
	m$(30) = "U Start ext. Trigger Eing."
	m$(31) = "V Endschalter +/-"
	m$(32) = "W Stop mit Konditionen"
	m$(33) = "X Nullpunktfahrt"
	m$(34) = "Y Druckmarken Unterdrck."
	m$(35) = "Z Achse Referenzlauf"
END IF

j = 0
k = 0
FOR i = 1 TO 35
   a$ = LEFT$(m$(i), 1)
   IF a$ <> "-" THEN
	LOCATE 12 + j, 1 + k: COLOR 11, 1: PRINT LEFT$(m$(i), 2);
   ELSE
	LOCATE 12 + j, 1 + k: COLOR 7, 1: PRINT LEFT$(m$(i), 2);
   END IF
 
   COLOR 7, 1: PRINT RIGHT$(m$(i), LEN(m$(i)) - 2);
   j = j + 1
   IF j > 12 THEN j = 0: k = k + 27
NEXT i

VIEW PRINT 2 TO 10      '* Stampa tra le righe 1 e 15.

CALL UpdateStatusLine

END SUB

SUB MascheraAPSPRG

'*****************************************
'* STAMPA MASCHERA COMANDI SULLO SCHERMO *
'*****************************************
DIM m$(40)

DRIVER$ = "APSPRG"

'----- Descrizione comandi sul video ---------
VIEW PRINT 1 TO 24

COLOR 0, 7                       ' Imposta il colore dello schermo.
LOCATE 1, 1, 1: PRINT STRING$(80, "-");
IF l = 1 THEN LOCATE 1, 27, 1: PRINT " i.v.b. STAR 2000 TERMINAL "
IF l = 2 THEN LOCATE 1, 27, 1: PRINT " i.v.b. STAR 2000 TERMINAL "
IF l = 3 THEN LOCATE 1, 27, 1: PRINT " i.v.b. STAR 2000 PROGRAMM "
LOCATE 1, 70: PRINT " Ver "; DSTARVERSION$; " "

COLOR 0, 3                        ' Imposta il colore dello schermo.
LOCATE 10, 1, 1: PRINT STRING$(80, "-");
LOCATE 10, 27, 1: PRINT " APS PROGRAMMING COMMANDS "
COLOR 7, 1                        ' Imposta il colore dello schermo.

IF l = 1 THEN
	m$(1) = "0 Selezione drive"
	m$(2) = "1 Parametri seriali"
	m$(3) = "2 Indirizzo drive"
	m$(4) = "3 Reset"
	m$(5) = "4 Corrente"
	m$(6) = "5 Frequenza minima"
	m$(7) = "6 Frequenza massima"
	m$(8) = "7 Rampa"
	m$(9) = "8 Posizionamento relativo"
	m$(10) = "9 Posizionamento assoluto"
	m$(11) = "A Movimento infinito"
	m$(12) = "B Ripeti l'ultimo posiz."
	m$(13) = "C Stop"
	m$(14) = "D Posizione di home"
	m$(15) = "F Risoluzione del motore"
	m$(16) = "G Riduzione di corrente"
	m$(17) = "H Livello uscita 'IN POS'"
	m$(18) = "I Ritardo seriale"
	m$(19) = "L Zero al volo"
	m$(20) = "Q Quota per 1 giro"
	m$(21) = "R Pos.Relativo [mm]"
	m$(22) = "S Pos.Relativo [mm] caric."
	m$(23) = "T Stop trigger esterno"
	m$(24) = "U Start trigger esterno"
	m$(25) = "V Set Extra corsa"
	m$(26) = "W Stop trigger esterno OR"
	m$(27) = "X Vai a home"
	m$(28) = "Y Quota iniziale z.fly"
	m$(29) = "Z Azzeramento"
	m$(30) = "---- EEPROM PROGRAM ----"
	m$(31) = "F1 Inizio acquis. prog."
	m$(32) = "F2 Fine acquis. prog."
	m$(33) = "F3 Modifica prog."
	m$(34) = "F4 Cancella prog."
	m$(35) = "F5 Cancella tutti i prog."
	m$(36) = "F6 Stato EEPROM"
	m$(37) = "F7 Repeti Prog."
	m$(38) = "F8 Pausa"
	m$(39) = "F9 Test EEPROM"
END IF

IF l = 2 THEN
	m$(1) = "0 Drive selection"
	m$(2) = "1 Serial parameters"
	m$(3) = "2 Drive address"
	m$(4) = "3 Reset"
	m$(5) = "4 Current setting"
	m$(6) = "5 Min frequency setting"
	m$(7) = "6 Max frequency setting"
	m$(8) = "7 Ramp setting"
	m$(9) = "8 Relative position"
	m$(10) = "9 Absolute position"
	m$(11) = "A Infinite motion"
	m$(12) = "B Start last position"
	m$(13) = "C Stop"
	m$(14) = "D Home position setting"
	m$(15) = "F Motor resolution set"
	m$(16) = "G Current reduction set"
	m$(17) = "H 'IN POSITION' out level"
	m$(18) = "I Serial answer delay"
	m$(19) = "L Zero at flight"
	m$(20) = "Q Quote/revolution"
	m$(21) = "R Rel.pos. [mm]"
	m$(22) = "S Rel.Pos. [mm] no exec"
	m$(23) = "T Stop extern trigger"
	m$(24) = "U Start extern trigger"
	m$(25) = "V Limit-switch +/-"
	m$(26) = "W Stop extern trigger OR"
	m$(27) = "X Go home"
	m$(28) = "Y Set start zfly quote"
	m$(29) = "Z Axis zeroing"
	m$(30) = "---- EEPROM PROGRAM ----"
	m$(31) = "F1 Begin capture program"
	m$(32) = "F2 End capture program"
	m$(33) = "F3 Edit program"
	m$(34) = "F4 Erase program"
	m$(35) = "F5 Erase all programs"
	m$(36) = "F6 Status EEPROM"
	m$(37) = "F7 Repeat program"
	m$(38) = "F8 Pause"
	m$(39) = "F9 Test EEPROM"
END IF

IF l = 3 THEN
	m$(1) = "0 Auswahl Endstufentyp"
	m$(2) = "1 Schnittstellenparameter"
	m$(3) = "2 Adresse Endstufe"
	m$(4) = "3 Reset"
	m$(5) = "4 Motorstrom Einstell."
	m$(6) = "5 min. Frequenz"
	m$(7) = "6 max. Frequenz"
	m$(8) = "7 Beschleunigung"
	m$(9) = "8 relativer Weg"
	m$(10) = "9 absoluter Weg"
	m$(11) = "A Dauerlauf"
	m$(12) = "B Wiederholung rel. Weg"
	m$(13) = "C Stop"
	m$(14) = "D Nullpunkt Einstell."
	m$(15) = "F Motorschrittaufloesung"
	m$(16) = "G Stromreduzierung"
	m$(17) = "H 'IN POSITION' Einstell."
	m$(18) = "I Zeitverz. ser. Antwort"
	m$(19) = "L Druckmarken Verfahrweg"
	m$(20) = "Q Eingabe Weg/Umdrehung"
	m$(21) = "R Rel.Weg [mm]"
	m$(22) = "S Rel.Weg [mm] ohne Ausf."
	m$(23) = "T Stop ext. Trigger Eing."
	m$(24) = "U Start ext. Trigger Eing."
	m$(25) = "V Endschalter +/-"
	m$(26) = "W Stop mit Konditionen"
	m$(27) = "X Nullpunktfahrt"
	m$(28) = "Y Druckmarken Unterdrck."
	m$(29) = "Z Achse Referenzlauf"
	m$(30) = "---- EEPROM PROGRAM ----"
	m$(31) = "F1 Beginn Eingabe Satz"
	m$(32) = "F2 Ende Eingabe Satz"
	m$(33) = "F3 Satz ndern"
	m$(34) = "F4 Satz lschen"
	m$(35) = "F5 Alle Stze lschen"
	m$(36) = "F6 Status EEPROM"
	m$(37) = "F7 Satz wiederholen"
	m$(38) = "F8 Pause"
	m$(39) = "F9 Test EEPROM"
END IF

j = 0
k = 0
FOR i = 1 TO 39
   a$ = LEFT$(m$(i), 1)
   IF a$ <> "-" THEN
	LOCATE 12 + j, 1 + k: COLOR 11, 1: PRINT LEFT$(m$(i), 2);
   ELSE
	LOCATE 12 + j, 1 + k: COLOR 7, 1: PRINT LEFT$(m$(i), 2);
   END IF
  
   COLOR 7, 1: PRINT RIGHT$(m$(i), LEN(m$(i)) - 2);
   j = j + 1
   IF j > 12 THEN j = 0: k = k + 27
NEXT i

VIEW PRINT 2 TO 10      '* Stampa tra le righe 1 e 15.

CALL UpdateStatusLine


END SUB

SUB MascheraSIO

'*****************************************
'* STAMPA MASCHERA COMANDI SULLO SCHERMO *
'*****************************************
DIM m$(40)

DRIVER$ = "SIO"

'----- Descrizione comandi sul video ---------
VIEW PRINT 1 TO 24
COLOR 7, 1                        ' Imposta il colore dello schermo.

COLOR 0, 7                       ' Imposta il colore dello schermo.
LOCATE 1, 1, 1: PRINT STRING$(80, "-");
IF l = 1 THEN LOCATE 1, 27, 1: PRINT " i.v.b. STAR 2000 TERMINAL "
IF l = 2 THEN LOCATE 1, 27, 1: PRINT " i.v.b. STAR 2000 TERMINAL "
IF l = 3 THEN LOCATE 1, 27, 1: PRINT " i.v.b. STAR 2000 PROGRAMM "
LOCATE 1, 70: PRINT " Ver "; DSTARVERSION$; " "
COLOR 0, 3                        ' Imposta il colore dello schermo.

LOCATE 10, 1, 1: PRINT STRING$(80, "-");
LOCATE 10, 26, 1: PRINT " SIO I/O INTERFACES COMMANDS "
COLOR 7, 1                        ' Imposta il colore dello schermo.

IF l = 1 THEN
	m$(1) = "0 Selezione drive"
	m$(2) = "1 Parametri seriali"
	m$(3) = "2 Indirizzo drive"
	m$(4) = "3 Reset"
	m$(5) = "4 Lettura ingressi"
	m$(6) = "5 Lettura ingresso analogico 1"
	m$(7) = "6 Lettura ingresso analogico 1"
	m$(8) = "7 Set uscite"
	m$(9) = "8 Set uscita analogica 1"
	m$(10) = "9 Set uscita analogica 1"
	m$(11) = "A Ritardo seriale"
	m$(12) = "B Versone software"
	m$(13) = "C Tipo scheda"
END IF

IF l = 2 THEN
	m$(1) = "0 Drive selection"
	m$(2) = "1 Serial parameters"
	m$(3) = "2 Drive address"
	m$(4) = "3 Reset"
	m$(5) = "4 Read inputs"
	m$(6) = "5 Read analog input 1"
	m$(7) = "6 Read analog input 2"
	m$(8) = "7 Set outputs"
	m$(9) = "8 Set analog output 1"
	m$(10) = "9 Set analog output 2"
	m$(11) = "A Serial answer delay"
	m$(12) = "B Software release"
	m$(13) = "C PCB type"
END IF
IF l = 3 THEN
	m$(1) = "0 Auswahl Endstufe"
	m$(2) = "1 Schnittstellenparameter"
	m$(3) = "2 Adresse Endstufe"
	m$(4) = "3 Reset"
	m$(5) = "4 Read inputs"
	m$(6) = "5 Read analog input 1"
	m$(7) = "6 Read analog input 2"
	m$(8) = "7 Set outputs"
	m$(9) = "8 Set analog output 1"
	m$(10) = "9 Set analog output 2"
	m$(11) = "A Serial answer delay"
	m$(12) = "B Software release"
	m$(13) = "C PCB type"
END IF


j = 0
k = 0
FOR i = 1 TO 13
   a$ = LEFT$(m$(i), 1)
   IF a$ <> "-" THEN
	LOCATE 12 + j, 1 + k: COLOR 11, 1: PRINT LEFT$(m$(i), 2);
   ELSE
	LOCATE 12 + j, 1 + k: COLOR 7, 1: PRINT LEFT$(m$(i), 2);
   END IF

   COLOR 7, 1: PRINT RIGHT$(m$(i), LEN(m$(i)) - 2);
   j = j + 1
   IF j > 12 THEN j = 0: k = k + 27
NEXT i

VIEW PRINT 2 TO 10      '* Stampa tra le righe 1 e 15.

CALL UpdateStatusLine

END SUB

FUNCTION PRGCMDEdit$ (send)
'** COMANDO STAMPA PROGRAMMA n SU SERIALE **
N$ = LTRIM$(RTRIM$(STR$(EEPRGMAX#)))
IF l = 1 THEN PRINT "Modifica programma N[0.."; N$; "] = ";
IF l = 2 THEN PRINT "Edit program N[0.."; N$; "] = ";
IF l = 3 THEN PRINT "Satz ndern Nr. [0.."; N$; "] = ";

STAMPAPGM = SpecialInput#(0, EEPRGMAX#, 3)

IF ABORTCOMMAND = 1 THEN EXIT FUNCTION
Comando$ = CHR$(&HF2) + CHR$(STAMPAPGM)

'*CANCELLAZIONE ARRAY PROGRAMMA E DECODIFICA*
FOR i = 1 TO 512
	PRG$(i) = ""
	CODE$(i) = ""
NEXT i

CALL TxRxSeriale(Comando$, 0, 0)  '------non aspetto rx nella routine

'*** RITARDO PRIMA DELLA RICEZIONE ***
FOR ii = 1 TO 80
	FOR jj = 1 TO 1000: NEXT jj
NEXT ii

'** lettura seriale **
N = 1
IF l = 1 THEN PRINT "     LETTURA PROGRAMMA IN CORSO...";
IF l = 2 THEN PRINT "     READING PROGRAM...";
IF l = 3 THEN PRINT "     lese Programm...";

RECEIVE$ = ""
i = 0
DO
	FOR ii = 1 TO 300
		FOR jj = 1 TO 100: NEXT jj
	NEXT ii
	IF EOF(1) THEN EXIT DO
	Recmio$ = INPUT$(1, #1)
	RECEIVE$ = RECEIVE$ + Recmio$
'       PRINT USING "## -"; i; : PRINT ConvHEX$(Recmio$); " ";
i = i + 1
LOOP

FOR ii = 1 TO 300
	FOR jj = 1 TO 100: NEXT jj
NEXT ii

IF LEFT$(RECEIVE$, 1) = "" OR LEN(RECEIVE$) = 0 OR RECEIVE$ = CHR$(&H15) THEN
	IF l = 1 THEN PRINT " PROGRAMMA VUOTO"
	IF l = 2 THEN PRINT " PROGRAM EMPTY"
	IF l = 3 THEN PRINT " Programm leer"
	EXIT FUNCTION
END IF

PRINT

IF l = 1 THEN PRINT "     Bytes totali ="; LEN(RECEIVE$)
IF l = 2 THEN PRINT "     Total Bytes  ="; LEN(RECEIVE$)
IF l = 3 THEN PRINT "     Total Bytes  ="; LEN(RECEIVE$)

PC = 1
i = 1

CALL decode(RECEIVE$)

'* cancella lo schermo
FOR i = 1 TO 20: PRINT : NEXT i
LOCATE 2, 1

'* STAMPA IL PROGRAMMA *
N = PC
IF l = 1 THEN
   PRG$(0) = "-- INIZIO PROGRAMMA --" + SPACE$(50)
   PRG$(N) = "--  FINE PROGRAMMA  --" + SPACE$(50)
END IF

IF l = 2 THEN
   PRG$(0) = "-- START PROGRAM --" + SPACE$(50)
   PRG$(N) = "--  END PROGRAM  --" + SPACE$(50)
END IF

IF l = 3 THEN
   PRG$(0) = "-- START PROGRAMM --" + SPACE$(50)
   PRG$(N) = "--  ENDE PROGRAMM --" + SPACE$(50)
END IF


'******* EDIT PROGRAM ******


OffsetVisual = 0
FinePrg = N
finestra = 5
ristampa = 1
PntPrg = 1
DO
   LOCATE 2, 1
   IF ristampa THEN
	   COLOR 0, 3
	   nn$ = LTRIM$(RTRIM$(STR$(STAMPAPGM)))
	   IF LEN(nn$) = 1 THEN nn$ = " " + nn$
	   IF l = 1 THEN PRINT " PRG."; nn$; " -FRECCIE=BROWSE [CANC]=CANCELLA [INS]=INSER. [FINE]=USCITA [F10]=STAMPA "
	   IF l = 2 THEN PRINT " PRG."; nn$; " - ARROWS=BROWSE  [DEL]=ERASE  [INS]=INSERT  [END]=EXIT  [F10]=PRINT     "
	   IF l = 3 THEN PRINT " PRG."; nn$; " - ARROWS=BROWSE  [DEL]=ERASE  [INS]=INSERT  [END]=EXIT  [F10]=PRINT     "
	   COLOR 7, 1
	   IF FinePrg < (finestra + OffsetVisual) THEN
		FineVisual = FinePrg
	   ELSE
		FineVisual = finestra + OffsetVisual
	   END IF

	   FOR i = OffsetVisual TO FineVisual
		   IF LEFT$(PRG$(i), 1) <> "-" THEN
			a$ = ConvHEX$(PRG$(i))
			
			IF PntPrg = i THEN
			    COLOR 14, 1: PRINT "->"; : COLOR 7, 1: PRINT USING "## "; i;
			ELSE
			    COLOR 7, 1: PRINT USING "  ## "; i;
			END IF
			PRINT " -"; : PRINT a$; TAB(30); CODE$(i);
		       
			C = POS(0)
			PRINT SPACE$(79 - C)
		   ELSE
			IF PRG$(i) <> "" THEN PRINT PRG$(i)
			IF i = N AND N < finestra THEN PRINT : EXIT FOR
		   END IF
	   NEXT i
	   C = CSRLIN
	   FOR i = C TO finestra + 3
		LOCATE i, 1: PRINT SPACE$(79)
	   NEXT i
	   ristampa = 0
   END IF
  
   TastoInput$ = INKEY$

   IF TastoInput$ <> "" THEN
	IF TastoInput$ = "F" THEN
		TastoInput1$ = INKEY$
		IF TastoInput1$ <> "" THEN TastoInput$ = "F" + TastoInput1$
	END IF
			      
	IF LEFT$(TastoInput$, 1) = CHR$(0) THEN
		TastoInput1$ = RIGHT$(TastoInput$, 1)
		IF TastoInput1$ <> "" THEN TastoInput$ = "S" + TastoInput1$
	END IF
   END IF
  
  SELECT CASE TastoInput$
	CASE "FA"      '*PRINT PROGRAM
		ristampa = 1
		LOCATE 9, 1:
		IF l = 1 THEN PRINT "STAMPO IL PROGRAMMA ? [ESC=NO 1=SI] ";
		IF l = 2 THEN PRINT "PRINT PROGRAM ? [ESC=NO 1=YES] ";
		IF l = 3 THEN PRINT "Programm ausdrucken ? [ESC=nein 1=ja] ";
		x = SpecialInput#(0, 1, 1)
		LOCATE 9, 1: PRINT SPACE$(79); : LOCATE 9, 1
		     
		IF ABORTCOMMAND = 0 THEN
			pag = 0
			FOR nn = 0 TO FinePrg - 1
			   IF nn = 0 OR nn = 60 OR nn = 120 OR nn = 180 THEN
				   IF nn <> 0 THEN LPRINT CHR$(12): LPRINT
				   pag = pag + 1
                                   LPRINT "i.v.b. STAR 2000 - PRG."; STAMPAPGM; TAB(70); "PAG."; pag
				   IF l = 1 THEN LPRINT "LINEA   COMANDO"; TAB(35); "FUNZIONE"
				   IF l = 2 THEN LPRINT "LINE    COMMAND"; TAB(35); "FUNCTION"
				   IF l = 3 THEN LPRINT "LINE    COMMAND"; TAB(35); "FUNCTION"
				   LPRINT
			   END IF
		       
			IF nn <> 0 THEN LPRINT USING "###  - "; nn; : LPRINT ConvHEX$(PRG$(nn)); TAB(35); CODE$(nn)
		       
			NEXT nn
			LPRINT CHR$(12): LPRINT
		END IF

	CASE "S" + CHR$(83): '*<canc>*
		ristampa = 1
		LOCATE 9, 1:
		IF l = 1 THEN PRINT "CANCELLO IL COMANDO SELEZIONATO ? [ESC=NO 1=SI] ";
		IF l = 2 THEN PRINT "ERASE SELECTED COMMAND ? [ESC=NO 1=YES] ";
		IF l = 3 THEN PRINT "Ausgewhlten Befehl lschen ? [ESC=nein 1=ja] ";
		x = SpecialInput#(0, 1, 1)
		IF x = 1 THEN
			FOR nn = PntPrg TO FinePrg
			   PRG$(nn) = PRG$(nn + 1)
			   CODE$(nn) = CODE$(nn + 1)
			NEXT nn
			PRG$(FinePrg) = ""
			CODE$(FinePrg) = ""
			FinePrg = FinePrg - 1
			IF PntPrg > 1 THEN PntPrg = PntPrg - 1
		END IF
       
	CASE "S" + CHR$(82): '*<ins>*
		ristampa = 1
		VIEW PRINT 3 TO 9
		LOCATE 9, 1:
		IF l = 1 THEN PRINT "INSERIMENTO COMANDO ? [ESC=NO 1=SI] ";
		IF l = 2 THEN PRINT "INSERT COMMAND ? [ESC=NO 1=YES] ";
		IF l = 3 THEN PRINT "Befehl einfgen ? [ESC=nein 1=ja] ";
		x = SpecialInput#(0, 1, 1)
		LOCATE 9, 1: PRINT SPACE$(79); : LOCATE 9, 1
		      
		IF ABORTCOMMAND = 0 THEN
			a$ = InsertCMD$
			IF a$ <> "" AND a$ <> "ABORT" THEN
				'* creo una locazione per la nuova istruzione
				FOR nn = FinePrg + 1 TO PntPrg STEP -1
				   PRG$(nn) = PRG$(nn - 1)
				   CODE$(nn) = CODE$(nn - 1)
				NEXT nn
								      
				PRG$(PntPrg) = ""
				CODE$(PntPrg) = ""
				FinePrg = FinePrg + 1
			       
				'* aggiungo l'istruzione
				PRG$(PntPrg) = a$
				p$ = ""

				'ricreo la stringa completa per decodificarla
				FOR ii = 1 TO FinePrg - 1
					p$ = p$ + PRG$(ii)
				NEXT ii
				
				CALL decode(p$)         'decodifico
			END IF
		END IF
		VIEW PRINT 2 TO 9
       
	CASE "S" + CHR$(79): '*<fine>*
		LOCATE 9, 1:
		IF l = 1 THEN PRINT "ESCO E SALVO LE MODIFICHE ESEGUITE ? [ESC=EDIT 0=NO 1=YES] ";
		IF l = 2 THEN PRINT "EXIT AND SAVE MODIFY ? [ESC=EDIT 0=NO 1=YES] ";
		IF l = 3 THEN PRINT "Ende und nderungen speichern ? [ESC=ndern 0=nein 1=ja] ";
		x = SpecialInput#(0, 1, 1)
	       
		IF (ABORTCOMMAND <> 1) THEN
		   IF x = 1 THEN
		      '* cancella lo schermo
		      FOR i = 1 TO 20: PRINT : NEXT i
		      LOCATE 2, 1
		     
		      '*cancella il programma
		      Comando$ = PRGCMDErase$(1, STAMPAPGM)
		     
		      '*start acquisizione del prog. corrente
		      IF l = 1 THEN PRINT "     INVIO DEL PROGRAMMA ALL'AZIONAMENTO:"
		      IF l = 2 THEN PRINT "     SEND PROGRAM TO DRIVER:"
		      IF l = 3 THEN PRINT "     speichere Programm  :"
		     
		      Comando$ = CHR$(&HF0) + CHR$(STAMPAPGM)
		      CALL TxRxSeriale(Comando$, 1, 1)
		      IF RECEIVE$ <> CHR$(&H6) THEN
			IF l = 1 THEN PRINT "     ERRORE NELLA CANCELLAZIONE DEL PROGRAMMA"
			IF l = 2 THEN PRINT "     ERASING PROGRAM ERROR"
			IF l = 3 THEN PRINT "     ERASING PROGRAM ERROR"
			EXIT FUNCTION
		      END IF
		     
		      '*invia i comandi all'azionamento
		      FOR ii = 1 TO FinePrg - 1
			  CALL TxRxSeriale(PRG$(ii), 1, 1)
			  IF RECEIVE$ <> CHR$(&H6) THEN
			    IF l = 1 THEN PRINT "     ERRORE NELLA CANCELLAZIONE DEL PROGRAMMA"
			    IF l = 2 THEN PRINT "     ERASING PROGRAM ERROR"
			    IF l = 3 THEN PRINT "     ERASING PROGRAM ERROR"
			    EXIT FUNCTION
			  END IF
		      NEXT ii
		    
		      '*fine acquisizione del prog.
		      Comando$ = CHR$(&HF1)
		      CALL TxRxSeriale(Comando$, 1, 1)
		     
		      IF l = 1 THEN PRINT "     FINE DOWNOLAD PROGRAMMA NELLA EEPROM"
		      IF l = 2 THEN PRINT "     END DOWNLOAD PROGRAM TO EEPROM"
		      IF l = 3 THEN PRINT "     Programm Abspeicherung beendet"
		     
		      EXIT FUNCTION
		   END IF
	       
		   IF x = 0 THEN
			'* cancella lo schermo
			FOR i = 1 TO 20: PRINT : NEXT i
			LOCATE 2, 1
			EXIT FUNCTION
		   END IF
		END IF
		ristampa = 1
       
	CASE "S" + CHR$(72): '*freccia su*
		ristampa = 1
		IF PntPrg > 1 THEN PntPrg = PntPrg - 1
		IF PntPrg <= OffsetVisual THEN
			OffsetVisual = OffsetVisual - 1
			IF OffsetVisual < 0 THEN OffsetVisual = 0
		END IF
       
	CASE "S" + CHR$(80): '*freccia gi*
		ristampa = 1
		IF PntPrg < (FinePrg - 1) THEN PntPrg = PntPrg + 1
		IF PntPrg >= (OffsetVisual + finestra) THEN
			OffsetVisual = OffsetVisual + 1
			IF (OffsetVisual + finestra) > FinePrg THEN OffsetVisual = FinePrg - finestra
		END IF
   CASE ELSE
   END SELECT
LOOP

END FUNCTION

FUNCTION PRGCMDErase$ (send, prog)

N$ = LTRIM$(RTRIM$(STR$(EEPRGMAX#)))

IF prog > 30 THEN
	'** COMANDO CANCELLAZIONE PROGRAMMA n EEPROM **
	IF l = 1 THEN PRINT "Cancellazione programma N [0.."; N$; "] = ";
	IF l = 2 THEN PRINT "Erase program N [0.."; N$; "] = ";
	IF l = 3 THEN PRINT "Satz lschen Nr. [0.."; N$; "] = ";

	PGMERASE = SpecialInput#(0, EEPRGMAX#, 3)

	IF ABORTCOMMAND = 1 THEN EXIT FUNCTION
ELSE
	PGMERASE = prog
END IF

Comando$ = CHR$(&HF3) + CHR$(PGMERASE)

PRGCMDErase$ = Comando$

IF send = 1 THEN
	IF l = 1 THEN PRINT "     CANCELLAZIONE DEL PRG."; PGMERASE; "IN CORSO... "
	IF l = 2 THEN PRINT "     PRG."; PGMERASE; "ERASING IN PROGRESS... "
	IF l = 3 THEN PRINT "     Programm"; PGMERASE; "wird gelscht, bitte warten... "
       
	CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

	IF RECEIVE$ = CHR$(&H15) THEN
		IF l = 1 THEN PRINT "     ERRORE! IL PROGRAMMA NON ESISTE"
		IF l = 2 THEN PRINT "     ERROR! PROGRAM NOT EXIST"
		IF l = 3 THEN PRINT "     ERROR! PROGRAM NOT EXIST"
	END IF

	IF RECEIVE$ = CHR$(&H6) THEN
		IF l = 1 THEN PRINT "     CANCELLAZIONE PROGRAMMA ESEGUITA"
		IF l = 2 THEN PRINT "     PROGRAM SUCCESFULLY ERASE"
		IF l = 3 THEN PRINT "     PROGRAM SUCCESFULLY ERASE"
	END IF

END IF

END FUNCTION

FUNCTION PRGCMDEraseAll$ (send)

'** COMANDO DI CANCELLAZIONE DI TUTTA LA EEPROM **
IF l = 1 THEN
	PRINT "Cancellazione di tutti i programmi. Confermi [0=NO 1=SI] ";
	ERASEALL = SpecialInput#(0, 2, 2)
	IF ABORTCOMMAND = 1 OR ERASEALL = 0 THEN EXIT FUNCTION
END IF

IF l = 2 THEN
	PRINT "Erase all programs. Confirm [0=NO 1=YES] ";
	ERASEALL = SpecialInput#(0, 2, 2)
	IF ABORTCOMMAND = 1 OR ERASEALL = 0 THEN EXIT FUNCTION
END IF

IF l = 3 THEN
	PRINT "Alle Stze lschen. [0=nein 1=ja] ";
	ERASEALL = SpecialInput#(0, 2, 2)
	IF ABORTCOMMAND = 1 OR ERASEALL = 0 THEN EXIT FUNCTION
END IF

Comando$ = CHR$(&HF9)
PRGCMDEraseAll$ = Comando$

IF send = 1 THEN
	'** lettura seriale **
	IF l = 1 THEN PRINT "     CANCELLAZIONE IN CORSO... "
	IF l = 2 THEN PRINT "     ERASE IN PROGRESS... "
	IF l = 3 THEN PRINT "     es wird gelscht... "
       
	CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

	IF RECEIVE$ = CHR$(&H6) THEN
		IF l = 1 THEN PRINT "     CANCELLAZIONE EEPROM ESEGUITA"
		IF l = 2 THEN PRINT "     EEPROM SUCCESSFULLY ERASE"
		IF l = 3 THEN PRINT "     EEPROM wurde gelscht"
	ELSE
		PRINT "ERROR"
	END IF
END IF

END FUNCTION

FUNCTION PRGCMDPausa$ (send)

'** COMANDO PAUSA DURANTE L'ESECUZIONE DI UN PROGRAMMA NELLA EEPROM **
IF l = 1 THEN PRINT "Pausa [da 0 a 255 1/10 Sec] = ";
IF l = 2 THEN PRINT "Wait [from 0 to 255 1/10 Sec] = ";
IF l = 3 THEN PRINT "Pause [von 0 bis 255 cS auf 10kHz] = ";
					 
PAUSA = SpecialInput#(0, 255, 3)
IF ABORTCOMMAND = 1 THEN EXIT FUNCTION

Comando$ = CHR$(&HF4) + CHR$(PAUSA)
PRGCMDPausa$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

FUNCTION PRGCMDPrintAll$ (send)
'** COMANDO STAMPA TUTTA LA EEPROM SULLA SERIALE **
Comando$ = CHR$(&HFC)

'*CANCELLAZIONE ARRAY PROGRAMMA*
FOR i = 1 TO 255
	PRG$(i) = ""
NEXT i

IF l = 1 THEN PRINT "EEPROM LIST: (FERMA/CONTINUA CON <BARRA SPAZIATRICE>)"
IF l = 2 THEN PRINT "EEPROM LIST: (PAUSE/CONTINUE WITH <SPACE BAR>)"
IF l = 3 THEN PRINT "EEPROM LIST: (PAUSE/CONTINUE WITH <SPACE BAR>)"

RECEIVE$ = ""
CALL TxRxSeriale(Comando$, 2, 0)
'** lettura seriale **
N = 1
i = 0
DO
	FOR ii = 1 TO 300
		FOR jj = 1 TO 100: NEXT jj
	NEXT ii
	IF EOF(1) THEN EXIT DO
	Recmio$ = INPUT$(1, #1)
	RECEIVE$ = RECEIVE$ + Recmio$
	COLOR 1, 7: PRINT USING "###"; i; : COLOR 7, 1: PRINT ConvHEX$(Recmio$); "  "; : COLOR 7, 1
	IF i = 33 THEN PRINT : PRINT
       
	DO  '*pause/continue dump con spazio
	   a$ = INKEY$
	   IF a$ = "" THEN EXIT DO
	   IF a$ = CHR$(32) THEN b$ = INPUT$(1): EXIT DO
	LOOP
i = i + 1
LOOP
COLOR 7, 1
PRINT
IF l = 1 THEN PRINT "     Bytes totali ="; LEN(RECEIVE$) - 1
IF l = 2 THEN PRINT "     Total Bytes  ="; LEN(RECEIVE$) - 1
IF l = 3 THEN PRINT "     Total Bytes  ="; LEN(RECEIVE$) - 1

PRINT


END FUNCTION

FUNCTION PRGCMDReadAddr$ (send)

'** COMANDO EEPROM - READ DATA **
IF l = 1 THEN PRINT "Indirizzo EEPROM da leggere [da 0 a 511] = ";
IF l = 2 THEN PRINT "EEPROM Read address [from 0 to 511] = ";
IF l = 3 THEN PRINT "EEPROM Read address [da 0 a 511] = ";

ADDR# = SpecialInput#(0, 511, 4)
IF ABORTCOMMAND = 1 THEN EXIT FUNCTION


Comando$ = CHR$(&HFE) + CHR$(ADDR# \ 256) + CHR$(ADDR# MOD 256)
PRGCMDReadAddr$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 5)

END FUNCTION

FUNCTION PRGCMDRepeat$ (send)

'** COMANDO RIPETIZIONE PROGRAMMA **
IF l = 1 THEN PRINT "Ripeti l'esecuzione del programma"
IF l = 2 THEN PRINT "Repeat program"
IF l = 3 THEN PRINT "Satz wiederholen"

Comando$ = CHR$(&HF5)
PRGCMDRepeat$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

FUNCTION PRGCMDStart$ (send)

N$ = LTRIM$(RTRIM$(STR$(EEPRGMAX#)))

'** COMANDO START PROGRAMMA n EEPROM **
IF l = 1 THEN PRINT "Start programma N [0.."; N$; "] = ";
IF l = 2 THEN PRINT "Start program N [0.."; N$; "] = ";
IF l = 3 THEN PRINT "Start Program Nr. [0.."; N$; "] = ";

PGMSTART = SpecialInput#(0, EEPRGMAX#, 3)
IF ABORTCOMMAND = 1 THEN EXIT FUNCTION

Comando$ = CHR$(&HFA) + CHR$(PGMSTART)
PRGCMDStart$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

FUNCTION PRGCMDStartAcq$ (send)

N$ = LTRIM$(RTRIM$(STR$(EEPRGMAX#)))

'** COMANDO START ACQUISIZIONE PROGRAMMA EEPROM **
IF l = 1 THEN PRINT "Inizio acquisizione PRG N [0.."; N$; "] = ";
IF l = 2 THEN PRINT "Begin capture PRG N [0.."; N$; "] = ";
IF l = 3 THEN PRINT "Beginn Eingabe Satz PRG Nr. [0.."; N$; "] = ";

PROGCAPTURE = SpecialInput#(0, EEPRGMAX#, 3)

IF ABORTCOMMAND = 1 THEN PROGCAPTURE = 99: EXIT FUNCTION

Comando$ = CHR$(&HF0) + CHR$(PROGCAPTURE)
PRGCMDStartAcq$ = Comando$

IF send = 1 THEN
	CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)
	IF RECEIVE$ = "" THEN PROGCAPTURE = 99  '*errore rx
	IF RECEIVE$ = CHR$(&H15) THEN
		PROGCAPTURE = 99
		IF l = 1 THEN PRINT "     ERRORE! IL PROGRAMMA E' GIA' PRESENTE"
		IF l = 2 THEN PRINT "     ERROR! PROGRAM ALREADY EXIST"
		IF l = 3 THEN PRINT "     ERROR! PROGRAM ALREADY EXIST"
	END IF

	IF RECEIVE$ = CHR$(&H6) THEN
		IF l = 1 THEN PRINT "     ACQUISIZIONE PRG."; PROGCAPTURE; "ATTIVATA"
		IF l = 2 THEN PRINT "     CAPTURING PRG."; PROGCAPTURE; "ENABLED"
		IF l = 3 THEN PRINT "     CAPTURING PRG."; PROGCAPTURE; "ENABLED"
	END IF
END IF

END FUNCTION

FUNCTION PRGCMDStatus$ (send)

DIM Map(36)

'* Stato dei programmi nella eeprom
IF l = 1 THEN PRINT "STATO PROGRAMMI EEPROM:"
IF l = 2 THEN PRINT "EEPROM PROGRAMS STATUS:"
IF l = 3 THEN PRINT "EEPROM PROGRAMM STATUS:"

FOR ad = 0 TO ((EEPRGMAX# * 2) + 1)
  ADDR# = ad
  Comando$ = CHR$(&HFE) + CHR$(ADDR# \ 256) + CHR$(ADDR# MOD 256)
  CALL TxRxSeriale(Comando$, 2, 5)
 
  IF RECEIVE$ <> "" THEN
       IF LEN(RECEIVE$) = 5 THEN Map(ad) = ASC(MID$(RECEIVE$, 4, 1))
  ELSE
       Map(ad) = 0
       IF l = 1 THEN PRINT "     ERRORE"
       IF l = 2 THEN PRINT "     ERROR"
       IF l = 3 THEN PRINT "     Fehler"
       EXIT FUNCTION
  END IF
NEXT ad

FOR i = 0 TO (EEPRGMAX# * 2) STEP 2
   Map(i) = Map(i) * 2
   'PRINT "PRG"; i; ": start:"; Map(i); ", len:"; Map(i + 1)
NEXT i


IF EEPRGMAX# > 8 THEN
	      PRINT "     PRG Nr. 0   1   2   3   4   5   6   7   8   9  10  11  12  13  14  15  16"
	PRINT USING "     START ### ### ### ### ### ### ### ### ### ### ### ### ### ### ### ### ###"; Map(0); Map(2); Map(4); Map(6); Map(8); Map(10); Map(12); Map(14); Map(16); Map(18); Map(20); Map(22); Map(24); Map(26); Map(28); Map(30); Map(32)
	PRINT USING "     BYTES ### ### ### ### ### ### ### ### ### ### ### ### ### ### ### ### ###"; Map(1); Map(3); Map(5); Map(7); Map(9); Map(11); Map(13); Map(15); Map(17); Map(19); Map(21); Map(23); Map(25); Map(27); Map(29); Map(31); Map(33)
	bfree = 512 - ((EEPRGMAX# * 2) + 4) - Map(1) - Map(3) - Map(5) - Map(7) - Map(9) - Map(11) - Map(13) - Map(15) - Map(17) - Map(19) - Map(21) - Map(23) - Map(25) - Map(27) - Map(29) - Map(31)

ELSE
	      PRINT "     PRG Nr.   0   1   2   3   4   5   6   7   8"
	PRINT USING "     START   ### ### ### ### ### ### ### ### ###"; Map(0); Map(2); Map(4); Map(6); Map(8); Map(10); Map(12); Map(14); Map(16)
	PRINT USING "     BYTES   ### ### ### ### ### ### ### ### ###"; Map(1); Map(3); Map(5); Map(7); Map(9); Map(11); Map(13); Map(15); Map(17)
	bfree = 512 - ((EEPRGMAX# * 2) + 4) - Map(1) - Map(3) - Map(5) - Map(7) - Map(9) - Map(11) - Map(13) - Map(15)
END IF

IF l = 1 THEN PRINT "     BYTES LIBERI:"; bfree
IF l = 2 THEN PRINT "     BYTES FREE:"; bfree
IF l = 3 THEN PRINT "     BYTES FREE:"; bfree

END FUNCTION

FUNCTION PRGCMDStop$ (send)

'** COMANDO STOP PROGRAMMA n EEPROM **
IF l = 1 THEN PRINT "Stop programma"
IF l = 2 THEN PRINT "Stop program"
IF l = 3 THEN PRINT "Stop program"

IF ABORTCOMMAND = 1 THEN EXIT FUNCTION

Comando$ = CHR$(&HFB)
PRGCMDStop$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

FUNCTION PRGCMDStopAcq$ (send)

'** COMANDO STOP ACQUISIZIONE PROGRAMMA EEPROM **
IF l = 1 THEN PRINT "Fine acquisizione programma"
IF l = 2 THEN PRINT "End capture program"
IF l = 3 THEN PRINT "Ende Eingabe Satz"

Comando$ = CHR$(&HF1)
PRGCMDStopAcq$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

PROGCAPTURE = 99

END FUNCTION

FUNCTION PRGCMDTestEeprom$ (send)
'** COMANDO DI TEST EEPROM **

IF l = 1 THEN PRINT "Test EEPROM. Tutti i programmi saranno cancellati. Confermi [0=NO 1=SI] ";
IF l = 2 THEN PRINT "Test EEPROM. All programs will be erased. Confirm [0=NO 1=YES] ";
IF l = 3 THEN PRINT "Test EEPROM. Alle Programme werden gelscht. [0=nein 1=ja] ";

ERASEALL = SpecialInput#(0, 2, 2)
IF ABORTCOMMAND = 1 OR ERASEALL = 0 THEN EXIT FUNCTION
	
IF l = 1 THEN PRINT "Test EEPROM in corso... ";
IF l = 2 THEN PRINT "EEPROM test... ";
IF l = 3 THEN PRINT "EEPROM test... ";

y = CSRLIN
   
FOR ADDR = 0 TO 511
	'*leggo il dato presente all'indirizzo ADDR
	Comando$ = CHR$(&HFE) + CHR$(ADDR \ 256) + CHR$(ADDR MOD 256)
	CALL TxRxSeriale(Comando$, 2, 5)
	IF RECEIVE$ <> "" THEN
	   a = LEN(RECEIVE$)
	   DatoOriginale = ASC(MID$(RECEIVE$, a - 1, 1))
	END IF
       
	dtx = &HAA      'scrivo 10101010
	Comando$ = CHR$(&HFD) + CHR$(ADDR \ 256) + CHR$(ADDR MOD 256) + CHR$(dtx)
	CALL TxRxSeriale(Comando$, 2, 1)
       
	Comando$ = CHR$(&HFE) + CHR$(ADDR \ 256) + CHR$(ADDR MOD 256)
	CALL TxRxSeriale(Comando$, 2, 5)
	IF RECEIVE$ <> "" THEN
	   a = LEN(RECEIVE$)
	   drx = ASC(MID$(RECEIVE$, a - 1, 1))
	END IF
	IF dtx <> drx THEN PRINT "ERROR": EXIT FUNCTION
       
	dtx = &H55      'scrivo 01010101
	Comando$ = CHR$(&HFD) + CHR$(ADDR \ 256) + CHR$(ADDR MOD 256) + CHR$(dtx)
	CALL TxRxSeriale(Comando$, 2, 1)
	Comando$ = CHR$(&HFE) + CHR$(ADDR \ 256) + CHR$(ADDR MOD 256)
	CALL TxRxSeriale(Comando$, 2, 5)
	IF RECEIVE$ <> "" THEN
	   a = LEN(RECEIVE$)
	   drx = ASC(MID$(RECEIVE$, a - 1, 1))
	END IF
	IF dtx <> drx THEN PRINT "ERROR": EXIT FUNCTION
       
	dtx = DatoOriginale   'Riscrivo il dato originale
	Comando$ = CHR$(&HFD) + CHR$(ADDR \ 256) + CHR$(ADDR MOD 256) + CHR$(dtx)
	CALL TxRxSeriale(Comando$, 2, 1)

	perc = (ADDR / 511) * 100

	IF l = 1 THEN LOCATE y, 1: PRINT "     Test EEPROM in corso..."; perc; "% ";
	IF l = 2 THEN LOCATE y, 1: PRINT "     EEPROM test..."; perc; "% ";
	IF l = 3 THEN LOCATE y, 1: PRINT "     EEPROM test..."; perc; "% ";
       
	'PRINT USING "     WR/RD ADDR ### OK"; ADDR
NEXT ADDR

PRINT "OK "

END FUNCTION

FUNCTION PRGCMDWriteAddr$ (send)

'** COMANDO EEPROM WRITE DATA **
IF l = 1 THEN PRINT "Indirizzo EEPROM da scrivere [da 0 a 255] = ";
IF l = 2 THEN PRINT "EEPROM Write address [from 0 to 255] = ";
IF l = 3 THEN PRINT "EEPROM Write address [from 0 to 255] = ";
ADDR# = SpecialInput#(0, 511, 4)
IF ABORTCOMMAND = 1 THEN EXIT FUNCTION

IF l = 1 THEN PRINT "Dato da scrivere   [da 0 a 255] = ";
IF l = 2 THEN PRINT "EEPROM Write data  [from 0 to 255] = ";
IF l = 3 THEN PRINT "EEPROM Write data  [from 0 to 255] = ";

dato# = SpecialInput#(0, 255, 4)
IF ABORTCOMMAND = 1 THEN EXIT FUNCTION


Comando$ = CHR$(&HFD) + CHR$(ADDR# \ 256) + CHR$(ADDR# MOD 256) + CHR$(dato#)

PRGCMDWriteAddr$ = Comando$

IF send = 1 THEN CALL TxRxSeriale(Comando$, TIPOCOMANDO, 1)

END FUNCTION

SUB SioCommands (TastoInput$)
'* DECODIFICA COMANDI PER SIO *
  
   TIMEOUTSERIAL = TIMEOUTCOMMAND

   SELECT CASE TastoInput$
	CASE "FC": ' ** F12 - cambia lingua
		IF l = 1 THEN l = 2:  ELSE IF l = 2 THEN l = 1
		CLS : CALL CambiaMaschera(1): ABORTCOMMAND = 1
	CASE CHR$(27): CLOSE : VIEW PRINT: COLOR 7, 0: CLS : END
	CASE "0": CLS : CALL CambiaMaschera(0): ABORTCOMMAND = 1
	CASE "1": CALL CMDSetSerial:    ABORTCOMMAND = 1
	CASE "2": CALL CMDSetAddr:      ABORTCOMMAND = 1
	CASE "3": Comando$ = CMDReset$(1)
	CASE "4": Comando$ = CMDReadInSio$(1)
	CASE "5": Comando$ = CMDReadAnin1$(1)
	CASE "6": Comando$ = CMDReadAnin2$(1)
	CASE "7": Comando$ = CMDSetOut$(1)
	CASE "8": Comando$ = CMDSetAnout1$(1)
	CASE "9": Comando$ = CMDSetAnout2$(1)
	CASE "A": Comando$ = CMDRitardoSeriale$(1)
	CASE "B": Comando$ = CMDVersioneSoft$(1)
	CASE "C": Comando$ = CMDTipoDrv$(1)
   CASE ELSE
	TIPOCOMANDO = 10
	PRINT
   END SELECT

   ABORTCOMMAND = 0
   Comando$ = ""
   TIPOCOMANDO = 1

END SUB

FUNCTION SpecialInput# (min#, max#, NChr)

ABORTCOMMAND = 0                'new

RigaInput = CSRLIN
ColInput = POS(0)

ChrInput$ = ""

COLOR 1, 7: PRINT STRING$(NChr + 1, " "); : COLOR 7, 1


LOCATE RigaInput, ColInput
PntChr = 1
DO
   a$ = INPUT$(1)
  
   '* Input carattere *
   IF (a$ >= "0" AND a$ <= "9" AND PntChr <= NChr) OR (a$ = "-" AND PntChr = 1) THEN
      ChrInput$ = ChrInput$ + a$
      PntChr = PntChr + 1
   END IF
   
   IF SETADDRESS = 1 AND UCASE$(a$) = "A" AND PntChr = 1 THEN
      ChrInput$ = ChrInput$ + UCASE$(a$)
      PntChr = PntChr + 1
      SWITCHALL = 1
   END IF
  
   IF SETADDRESS = 1 AND UCASE$(a$) = "M" AND PntChr = 1 THEN
      ChrInput$ = ChrInput$ + UCASE$(a$)
      PntChr = PntChr + 1
      SWITCHALL = 2
   END IF
  
   IF FLAGMA = 1 AND a$ = CHR$(13) AND PntChr = 1 THEN FLAGMA = 0: EXIT FUNCTION

   '* Backspace *
   IF a$ = CHR$(8) AND PntChr > 1 THEN
      ChrInput$ = LEFT$(ChrInput$, LEN(ChrInput$) - 1)
      PntChr = PntChr - 1
   END IF
  


   '* Invio *
   IF a$ = CHR$(13) AND ChrInput$ <> "" THEN
      x# = VAL(ChrInput$)
      IF x# >= min# AND x# <= max# THEN
	 COLOR COLORECOM
	 LOCATE RigaInput, (ColInput): PRINT ChrInput$; STRING$(NChr - LEN(ChrInput$) + 1, " ")'; " OK"
	 SpecialInput# = x#
	 EXIT FUNCTION
      ELSE
	 FOR i = 1 TO 4
	    LOCATE RigaInput, (ColInput + NChr + 2):
	    IF l = 1 THEN PRINT " ERRORE";
	    IF l = 2 THEN PRINT " ERROR ";
	    IF l = 3 THEN PRINT " ERROR ";
	    FOR j = 1 TO 100
		FOR k = 1 TO 2000: NEXT k
	    NEXT j
	    LOCATE RigaInput, (ColInput + NChr + 2): PRINT "       ";
	    FOR j = 1 TO 100
		FOR k = 1 TO 2000: NEXT k
	    NEXT j
	 NEXT i
	 LOCATE RigaInput, ColInput: PRINT "";
      END IF

   END IF
  
   '* Esco *
   IF a$ = CHR$(27) THEN
      ABORTCOMMAND = 1
      'LOCATE RigaInput, (ColInput + NChr + 2)
      LOCATE RigaInput, (ColInput) 'NChr + 2)
      IF l = 1 THEN PRINT "ANNULLATO  "
      IF l = 2 THEN PRINT "ABORTED    "
      IF l = 3 THEN PRINT "ABORTED    "

      EXIT FUNCTION
   END IF
  
   LOCATE RigaInput, ColInput: COLOR 1, 7: PRINT ChrInput$; " "; : COLOR 7, 1
   LOCATE RigaInput, ColInput + LEN(ChrInput$)
LOOP

END FUNCTION

SUB TxRxSeriale (Comando$, TIPOCOMANDO, NByteRx)
DIM IndMulti(10)
'* preparazione stringa da inviare *
'* TIPOCOMANDO=9 -> COMANDO DIRETTO SENZA ATTESA DI RISPOSTA
'* TIPOCOMANDO=2 -> NON STAMPA LA STRINGA DI TX

IF SWITCHALL = 0 AND TIPOCOMANDO <> 9 OR TIPOCOMANDO = 1 THEN
	'* comando diretto ad un solo indirizzo *
	BnB$ = BnbAdd$(Comando$)          '* Function calcolo 2 byte
	CmdTemp$ = CHR$(&HFC) + BnB$ + Comando$
	CmdTemp$ = CmdTemp$ + CHR$(CalcoloChksum(CmdTemp$))     '*aggiungo chksum
END IF

IF SWITCHALL = 1 OR TIPOCOMANDO = 9 THEN
	'* comando switchall (per tutti i drives) *
	BnB$ = CHR$(LEN(Comando$))
	CmdTemp$ = CHR$(&HFC) + CHR$(0) + BnB$ + Comando$
	CmdTemp$ = CmdTemp$ + CHR$(CalcoloChksum(CmdTemp$))     '*aggiungo chksum
END IF

IF SWITCHALL = 2 AND TIPOCOMANDO <> 9 THEN
	'* comando multiaddress (specificare indirizzi) *
	Nindirizzi = 6 - LEN(Comando$)      '* Numero massimo indirizzi di destinazione *
	IF l = 1 THEN PRINT "     E' possibile inviare questo comando a"; Nindirizzi; "azionamenti"
	IF l = 2 THEN PRINT "     Is possible send this command to"; Nindirizzi; "drives"
	IF l = 3 THEN PRINT "     Is possible send this command to"; Nindirizzi; "drives"
	Multiaddr$ = ""
	FOR i = 1 TO 10
		IndMulti(i) = 0
	NEXT i
	FLAGMA = 1
	FOR i = 1 TO Nindirizzi
		IF l = 1 THEN PRINT "    "; i; " INDIRIZZO [da 0 a 31] = "; : IndMulti(i) = SpecialInput#(0, 31, 2)
		IF l = 2 THEN PRINT "    "; i; " ADDRESS [from 0 to 31] = "; : IndMulti(i) = SpecialInput#(0, 31, 2)
		IF l = 3 THEN PRINT "    "; i; " ADDRESSE [from 0 to 31] = "; : IndMulti(i) = SpecialInput#(0, 31, 2)
		IF FLAGMA = 0 THEN PRINT : EXIT FOR
		IF ABORTCOMMAND = 1 THEN FLAGMA = 0: EXIT SUB
		Multiaddr$ = Multiaddr$ + CHR$(IndMulti(i))
	NEXT i
       
	FLAGMA = 0
       
	ADDRESS = 31
	Comando$ = CHR$(&HA5) + Comando$ + Multiaddr$
	BnB$ = BnbAdd$(Comando$)            '* Function calcolo 2 byte
	Comando$ = RIGHT$(Comando$, LEN(Comando$) - 1)
	CmdTemp$ = CHR$(&HFC) + BnB$ + CHR$(&HA5) + Comando$
	CmdTemp$ = CmdTemp$ + CHR$(CalcoloChksum(CmdTemp$))     '*aggiungo chksum
END IF


'*** COMUNICAZIONE SERIALE ***
PRINT #1, CmdTemp$;        '* ok trasmetti *
IF TIPOCOMANDO <> 2 THEN PRINT "     Tx->"; ConvHEX$(CmdTemp$);

IF TIPOCOMANDO = 0 THEN PRINT : EXIT SUB
IF TIPOCOMANDO = 9 THEN PRINT : EXIT SUB


IF FULLDUPLEX = 0 THEN
   '*** RITARDO PRIMA DELLA RICEZIONE ***
   FOR ii = 1 TO 80
	FOR jj = 1 TO 2000: NEXT jj
   NEXT ii
END IF

RECEIVE$ = ""

ErrorSerial = 0
'** lettura seriale **
StartTimer# = TIMER
IF SWITCHALL = 0 THEN
   DO
	DO
		IF EOF(1) THEN EXIT DO
		Recmio$ = INPUT$(1, #1)
	'       PRINT ">"; ASC(Recmio$); "<"
		RECEIVE$ = RECEIVE$ + Recmio$
	LOOP
       
	IF FULLDUPLEX = 1 THEN
	  IF LEN(RECEIVE$) = NByteRx THEN EXIT DO
	ELSE
	  EXIT DO
	END IF
	 
	   IF (TIMER - StartTimer#) > TIMEOUTSERIAL THEN
		ErrorSerial = 1
		IF SWITCHALL = 0 THEN
			PRINT TAB(40); "Rx-> TIMEOUT ERROR": EXIT DO
		ELSE
			PRINT : EXIT DO'** COMANDI SENZA RISPOSTA
		END IF
	  END IF
   LOOP
   IF TIPOCOMANDO <> 2 AND ErrorSerial = 0 THEN PRINT TAB(40); "Rx->"; ConvHEX$(RECEIVE$): 'TAB(40); ">"; Receive$; "<"
ELSE
   '*** RITARDO DOPO UN COMANDO SWITCHALL ***
   FOR ii = 1 TO 80
	FOR jj = 1 TO 2000: NEXT jj
   NEXT ii
   PRINT
END IF


'**** FINE COMUNICAZIONE SERIALE ***

END SUB

SUB UpdateStatusLine
'* Aggiorna linea STATUS con seriale ed indirizzo

a = CSRLIN
VIEW PRINT
COLOR 0, 7

IF l = 1 THEN
	LOCATE 11, 1: PRINT STRING$(80, " ");
	LOCATE 11, 1: PRINT "SERIALE: "; COM$; ", BAUD RATE:"; BAUD$;
	PRINT "    INDIRIZZO AZIONAMENTO:";

	IF SWITCHALL = 0 THEN PRINT ADDRESS;
	IF SWITCHALL = 1 THEN PRINT " TUTTI I DRIVES";
	IF SWITCHALL = 2 THEN PRINT " MULTIADDRESS  ";
       
	IF SWITCHALL = 0 THEN
		IF PROGCAPTURE <> 99 THEN
			PRINT "    ACQ. PRG Nr."; PROGCAPTURE
		ELSE
			PRINT "                  ";
		END IF
	END IF
END IF

IF l = 2 THEN
	LOCATE 11, 1: PRINT STRING$(80, " ");
	LOCATE 11, 1: PRINT "SERIAL:  "; COM$; ", BAUD RATE:"; BAUD$;
	PRINT "    DRIVE ADDRESS:";

	IF SWITCHALL = 0 THEN PRINT ADDRESS;
	IF SWITCHALL = 1 THEN PRINT " ALL THE DRIVES";
	IF SWITCHALL = 2 THEN PRINT " MULTIADDRESS  ";
       
	IF SWITCHALL = 0 THEN
		IF PROGCAPTURE <> 99 THEN
			PRINT " CAPTURING PRG Nr."; PROGCAPTURE
		ELSE
			PRINT "                    "
		 END IF
	END IF
END IF

IF l = 3 THEN
	LOCATE 11, 1: PRINT STRING$(80, " ");
	LOCATE 11, 1: PRINT "SERIAL:  "; COM$; ", BAUD RATE:"; BAUD$;
	PRINT "    ADRESSE ENDSTUFE:";

	IF SWITCHALL = 0 THEN PRINT ADDRESS;
	IF SWITCHALL = 1 THEN PRINT " ALL THE DRIVES";
	IF SWITCHALL = 2 THEN PRINT " MULTIADDRESS  ";
       
	IF SWITCHALL = 0 THEN
		IF PROGCAPTURE <> 99 THEN
			PRINT " CAPTURING PRG Nr."; PROGCAPTURE
		ELSE
			PRINT "                    "
		END IF
	END IF
END IF

COLOR 7, 1

'* AGGIORNAMENTO PARAMETRI IMPOSTATI - SOLO PER APS/APD *
IF DRIVER$ = "APS" THEN
	COLOR 10, 1
	LOCATE 16, 21: IF CORRENTE# <> 0 THEN PRINT USING "######"; CORRENTE# ELSE PRINT "     -"
	LOCATE 17, 21: IF FMIN <> 0 THEN PRINT USING "######"; FMIN ELSE PRINT "     -"
	LOCATE 18, 21: IF FMAX# <> 0 THEN PRINT USING "######"; FMAX# ELSE PRINT "     -"
	LOCATE 19, 21: IF RAMPA <> 0 THEN PRINT USING "######"; RAMPA ELSE PRINT "     -"
	COLOR 7, 1
END IF

VIEW PRINT 1 TO 24
COLOR 0, 7: LOCATE 25, 1: PRINT SPACE$(80); : COLOR 7, 1

LOCATE 25, 1
IF l = 1 THEN COLOR 0, 7: PRINT "        Premere <ESC> per uscire - <F12> per cambiare lingua ";
IF l = 2 THEN COLOR 0, 7: PRINT "         Press <ESC> to exit - <F12> to change language ";
IF l = 3 THEN COLOR 0, 7: PRINT "         Taste <ESC> fr Ende - <F12> ndern Sprache ";

'IF l = 1 THEN COLOR 14, 7: PRINT "ITA"; : COLOR 0, 7: PRINT "/ING/TED"; : COLOR 7, 1
'IF l = 2 THEN COLOR 0, 7: PRINT "ITA/"; : COLOR 14, 7: PRINT "ENG"; : COLOR 0, 7: PRINT "/DEU";
'IF l = 3 THEN COLOR 0, 7: PRINT "ITA/ENG/"; : COLOR 14, 7: PRINT "DEU";

IF l = 1 THEN COLOR 14, 7: GOSUB ita: COLOR 0, 7: PRINT "/ENG/DEU"; : COLOR 7, 1
IF l = 2 THEN COLOR 0, 7: PRINT "ITA/"; : GOSUB eng: COLOR 0, 7: PRINT "/DEU";
IF l = 3 THEN COLOR 0, 7: PRINT "ITA/ENG/"; : GOSUB deu


COLOR 7, 1
VIEW PRINT 2 TO 9      '* Stampa tra le righe 2 e 9.

LOCATE a, 1

GOTO FineSub

'* sub con colori delle lingue:
ita:
COLOR 10, 7: PRINT "I";
COLOR 15, 7: PRINT "T";
COLOR 12, 7: PRINT "A";
RETURN

eng:
COLOR 9, 7: PRINT "E";
COLOR 12, 7: PRINT "N";
COLOR 9, 7: PRINT "G";
RETURN

deu:
COLOR 0, 7: PRINT "D";
COLOR 12, 7: PRINT "E";
COLOR 14, 7: PRINT "U";
RETURN

FineSub:

END SUB

